/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/***************** gpre version LI-V3.0.4.33054 Firebird 3.0 **********************/
/*
 *	PROGRAM:	JRD Command Oriented Query Language
 *	MODULE:		show.epp
 *	DESCRIPTION:	Show environment commands
 *
 * The contents of this file are subject to the Interbase Public
 * License Version 1.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy
 * of the License at http://www.Inprise.com/IPL.html
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code was created by Inprise Corporation
 * and its predecessors. Portions created by Inprise Corporation are
 * Copyright (C) Inprise Corporation.
 *
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 */

#include "firebird.h"
#include <stdio.h>
#include <string.h>
#include "../jrd/ibase.h"
#include "../qli/dtr.h"
#include "../qli/parse.h"
#include "../qli/compile.h"
#include "../jrd/license.h"
#include "../qli/reqs.h"
#include "../jrd/flags.h"
#include "../qli/all_proto.h"
#include "../qli/comma_proto.h"
#include "../qli/err_proto.h"
#include "../qli/meta_proto.h"
#include "../qli/proc_proto.h"
#include "../qli/show_proto.h"
#include "../yvalve/gds_proto.h"
#include "../common/utils_proto.h"
#include "../common/classes/UserBlob.h"

using MsgFormat::SafeArg;


static void array_dimensions(qli_dbb*, const TEXT*);
static void display_acl(qli_dbb*, ISC_QUAD&);
static void display_blob(qli_dbb*, ISC_QUAD&, const TEXT*, USHORT, const UCHAR*, bool);
static void display_blr(qli_dbb*, ISC_QUAD&);
static void display_text(qli_dbb*, ISC_QUAD&, const TEXT*, bool);
static void display_procedure(qli_dbb*, const UCHAR*, FB_API_HANDLE);
static USHORT get_window_size(int);
static void show_blob_info(ISC_QUAD&, ISC_QUAD&, USHORT, USHORT, qli_dbb*, const TEXT*);
static void show_blr(qli_dbb*, USHORT, ISC_QUAD&, USHORT, ISC_QUAD&);
static void show_datatype(qli_dbb*, USHORT, USHORT, SSHORT, SSHORT, USHORT, USHORT);
static void show_dbb(qli_dbb*);
static void show_dbb_parameters(qli_dbb*);
static int show_field_detail(qli_dbb*, const TEXT*, const TEXT*, qli_syntax*);
static int show_field_instances(qli_dbb*, const TEXT*);
static void show_fields(qli_rel*, qli_fld*);
static void show_filt(qli_filter*);
static int show_filter_detail(qli_dbb*, const TEXT*);
static void show_filts(qli_dbb*);
static int show_filters_detail(qli_dbb*);
static void show_fld(qli_syntax*);
static void show_func(qli_func*);
static int show_func_detail(qli_dbb*, const TEXT*);
static void show_funcs(qli_dbb*);
static int show_funcs_detail(qli_dbb*);
static int show_insecure_fields(qli_dbb*, const TEXT*, const TEXT*);
static void show_gbl_field(qli_syntax*);
static int show_gbl_field_detail(qli_dbb*, const TEXT*);
static void show_gbl_fields(qli_dbb*);
static int show_gbl_fields_detail(qli_dbb*);
static int show_indices_detail(qli_rel*);
static void show_matching();
static void show_names(const TEXT*, USHORT, TEXT*);
static void show_proc(qli_proc*);
static void show_procs(qli_dbb*);
static void show_rel(qli_rel*);
static void show_rel_detail(qli_rel*);
static void show_rels(qli_dbb*, enum show_t, SSHORT);
static USHORT show_security_class_detail(qli_dbb*, const TEXT*);
static USHORT show_security_classes_detail(qli_dbb*);
static void show_string(USHORT, TEXT*, USHORT, TEXT*);
static void show_sys_trigs(qli_dbb*);
static void show_text_blob(qli_dbb*, const TEXT*, USHORT, ISC_QUAD*, USHORT, ISC_QUAD*, bool);
static void show_trig(qli_rel*);
static int show_trigger_detail(qli_dbb*, const TEXT*);
static void show_trigger_header(TEXT*, USHORT, USHORT, USHORT, ISC_QUAD&, qli_dbb*); // const TEXT*);
static void show_trigger_messages(qli_dbb*, const TEXT*);
static void show_trigger_status(TEXT*, USHORT, USHORT, USHORT);
static void show_trigs(qli_dbb*);
static int show_triggers_detail(qli_dbb*);
static void show_var(const qli_name*);
static void show_vars();
static void show_versions();
static void show_view(qli_rel*);
static int show_views_detail(qli_dbb*);
static void view_info(qli_dbb*, const TEXT*, const TEXT*, SSHORT, SSHORT);

static const SCHAR db_items[] =
{
	isc_info_page_size, isc_info_db_size_in_pages, isc_info_end
};
static const UCHAR acl_bpb[] =
{
	isc_bpb_version1, isc_bpb_source_type, 1, 3,
	isc_bpb_target_type, 1, 1
};
static const UCHAR blr_bpb[] =
{
	isc_bpb_version1, isc_bpb_source_type, 1, 2,
	isc_bpb_target_type, 1, 1
};

/*DATABASE DB = EXTERN FILENAME "yachts.lnk";*/
/**** GDS Preprocessor Definitions ****/
#ifndef JRD_IBASE_H
#include <ibase.h>
#endif

static const ISC_QUAD
   isc_blob_null = {0, 0};	/* initializer for blobs */
extern isc_db_handle
   DB;		/* database handle */

extern isc_tr_handle
   gds_trans;		/* default transaction handle */
extern ISC_STATUS
   isc_status [20],	/* status vector */
   isc_status2 [20];	/* status vector */
extern ISC_LONG
   isc_array_length, 	/* array return size */
   SQLCODE;		/* SQL status code */
static const short
   isc_0l = 327;
static const unsigned char
   isc_0 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 7,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 3,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 2, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 0, 
		     blr_relation, 18, 'R','D','B','$','V','I','E','W','_','R','E','L','A','T','I','O','N','S', 1, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			      blr_parameter, 0, 1,0, 
			   blr_and, 
			      blr_eql, 
				 blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
				 blr_field, 1, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_and, 
				 blr_eql, 
				    blr_field, 1, 13, 'R','D','B','$','V','I','E','W','_','N','A','M','E', 
				    blr_parameter, 0, 2,0, 
				 blr_eql, 
				    blr_field, 1, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
				    blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter2, 1, 0,0, 3,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','B','A','S','E','_','F','I','E','L','D', 
			   blr_parameter2, 1, 6,0, 4,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 1,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_0 */

static const short
   isc_13l = 149;
static const unsigned char
   isc_13 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 18, 'R','D','B','$','V','I','E','W','_','R','E','L','A','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 13, 'R','D','B','$','V','I','E','W','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_13 */

static const short
   isc_19l = 131;
static const unsigned char
   isc_19 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_not, 
			blr_missing, 
			   blr_field, 0, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
		  blr_sort, 1, 
		     blr_ascending, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_19 */

static const short
   isc_23l = 166;
static const unsigned char
   isc_23 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 4,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_not, 
			      blr_missing, 
				 blr_field, 0, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','V','I','E','W','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 1,0, 3,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 2,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 2,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_23 */

static const short
   isc_31l = 418;
static const unsigned char
   isc_31 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 10,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_int64, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_eql, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 0,0,0,0,
		  blr_sort, 4, 
		     blr_ascending, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
		     blr_ascending, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
		     blr_ascending, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
		     blr_ascending, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','T','R','I','G','G','E','R','_','S','O','U','R','C','E', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','T','R','I','G','G','E','R','_','B','L','R', 
			blr_parameter2, 0, 3,0, 7,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','I','N','A','C','T','I','V','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter, 0, 9,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 4,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_31 */

static const short
   isc_43l = 179;
static const unsigned char
   isc_43 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 3,0, 
	    blr_cstring2, 0,0, 0,4, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','M','E','S','S','A','G','E','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 18, 'R','D','B','$','M','E','S','S','A','G','E','_','N','U','M','B','E','R', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 11, 'R','D','B','$','M','E','S','S','A','G','E', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','M','E','S','S','A','G','E','_','N','U','M','B','E','R', 
			   blr_parameter, 1, 2,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 1,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_43 */

static const short
   isc_50l = 404;
static const unsigned char
   isc_50 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 9,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_int64, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_or, 
			      blr_missing, 
				 blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			      blr_eql, 
				 blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
				 blr_literal, blr_long, 0, 0,0,0,0,
		     blr_sort, 3, 
			blr_ascending, 
			   blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
			blr_ascending, 
			   blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
			blr_ascending, 
			   blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','T','R','I','G','G','E','R','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','T','R','I','G','G','E','R','_','B','L','R', 
			   blr_parameter2, 1, 3,0, 7,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','I','N','A','C','T','I','V','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			   blr_parameter, 1, 8,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 4,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_50 */

static const short
   isc_63l = 398;
static const unsigned char
   isc_63 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 10,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_int64, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		  blr_boolean, 
		     blr_eql, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_sort, 4, 
		     blr_ascending, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
		     blr_ascending, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
		     blr_ascending, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
		     blr_ascending, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','T','R','I','G','G','E','R','_','S','O','U','R','C','E', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','T','R','I','G','G','E','R','_','B','L','R', 
			blr_parameter2, 0, 3,0, 7,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','I','N','A','C','T','I','V','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter, 0, 9,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 4,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_63 */

static const short
   isc_75l = 115;
static const unsigned char
   isc_75 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 3,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 20, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S','E','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 7, 'R','D','B','$','A','C','L', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter, 0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_75 */

static const short
   isc_80l = 151;
static const unsigned char
   isc_80 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 3,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 20, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S','E','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 7, 'R','D','B','$','A','C','L', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_parameter, 1, 2,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 1,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_80 */

static const short
   isc_87l = 238;
static const unsigned char
   isc_87 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 7,0, 
	    blr_int64, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','T','R','I','G','G','E','R','_','B','L','R', 
			   blr_parameter2, 1, 1,0, 5,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','I','N','A','C','T','I','V','E', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			   blr_parameter, 1, 6,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 2,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_87 */

static const short
   isc_98l = 150;
static const unsigned char
   isc_98 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_not, 
			      blr_missing, 
				 blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','F','I','L','E', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','F','I','L','E', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 1,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_98 */

static const short
   isc_104l = 150;
static const unsigned char
   isc_104 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_not, 
			      blr_missing, 
				 blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_104 */

static const short
   isc_110l = 150;
static const unsigned char
   isc_110 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 3,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 2,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 1,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_110 */

static const short
   isc_117l = 118;
static const unsigned char
   isc_117 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 2,0, 
	    blr_cstring2, 0,0, 32,0, 
	    blr_short, 0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'Q','L','I','$','P','R','O','C','E','D','U','R','E','S', 0, 
		  blr_sort, 1, 
		     blr_ascending, 
			blr_field, 0, 18, 'Q','L','I','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 18, 'Q','L','I','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_117 */

static const short
   isc_121l = 148;
static const unsigned char
   isc_121 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 18, 'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','P','O','S','I','T','I','O','N', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_121 */

static const short
   isc_127l = 240;
static const unsigned char
   isc_127 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 3,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 2, 
		     blr_relation, 11, 'R','D','B','$','I','N','D','I','C','E','S', 0, 
		     blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 1, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_and, 
			      blr_eql, 
				 blr_field, 1, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
				 blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_missing, 
				 blr_field, 1, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','N','I','Q','U','E','_','F','L','A','G', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			   blr_parameter, 1, 2,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_127 */

static const short
   isc_134l = 148;
static const unsigned char
   isc_134 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 18, 'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','P','O','S','I','T','I','O','N', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_134 */

static const short
   isc_140l = 116;
static const unsigned char
   isc_140 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 11, 'R','D','B','$','I','N','D','I','C','E','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','T','Y','P','E', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_140 */

static const short
   isc_146l = 335;
static const unsigned char
   isc_146 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 8,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 2, 
		     blr_relation, 11, 'R','D','B','$','I','N','D','I','C','E','S', 0, 
		     blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 1, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_and, 
			      blr_eql, 
				 blr_field, 1, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
				 blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_missing, 
				 blr_field, 1, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','E','X','P','R','E','S','S','I','O','N','_','B','L','R', 
			   blr_parameter2, 1, 0,0, 3,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','E','X','P','R','E','S','S','I','O','N','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 1,0, 4,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','I','N','D','E','X','_','I','N','A','C','T','I','V','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','N','I','Q','U','E','_','F','L','A','G', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			   blr_parameter, 1, 7,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 2,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_146 */

static const short
   isc_158l = 337;
static const unsigned char
   isc_158 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 10,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_eql, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 0,0,0,0,
		  blr_sort, 1, 
		     blr_ascending, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			blr_parameter2, 0, 1,0, 8,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 9,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_158 */

static const short
   isc_170l = 465;
static const unsigned char
   isc_170 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 15,0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','B','L','R', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 19, 'R','D','B','$','C','O','M','P','U','T','E','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 8,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 9,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 10,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 11,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 12,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 13,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 14,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 7,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_170 */

static const short
   isc_189l = 892;
static const unsigned char
   isc_189 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 26,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 3,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 3, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 0, 
		     blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 1, 
		     blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 2, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			      blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_and, 
			      blr_eql, 
				 blr_field, 2, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
				 blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_or, 
				 blr_eql, 
				    blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
				    blr_parameter, 0, 0,0, 
				 blr_or, 
				    blr_eql, 
				       blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
				       blr_parameter, 0, 1,0, 
				    blr_and, 
				       blr_missing, 
					  blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
				       blr_eql, 
					  blr_field, 1, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
					  blr_parameter, 0, 2,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','B','L','R', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 1, 21, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 1, 19, 'R','D','B','$','C','O','M','P','U','T','E','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 8,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 9,0, 
			blr_assignment, 
			   blr_field, 2, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
			   blr_parameter2, 1, 10,0, 19,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 11,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 12,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 13,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 14,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 15,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 16,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 17,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 20,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 21,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 22,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','B','A','S','E','_','F','I','E','L','D', 
			   blr_parameter2, 1, 23,0, 18,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 24,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 25,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 11,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_189 */

static const short
   isc_221l = 113;
static const unsigned char
   isc_221 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','F','U','N','C','T','I','O','N','S', 0, 
		  blr_sort, 1, 
		     blr_ascending, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_221 */

static const short
   isc_225l = 290;
static const unsigned char
   isc_225 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 7,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 22, 'R','D','B','$','F','U','N','C','T','I','O','N','_','A','R','G','U','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 21, 'R','D','B','$','A','R','G','U','M','E','N','T','_','P','O','S','I','T','I','O','N', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','M','E','C','H','A','N','I','S','M', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','A','R','G','U','M','E','N','T','_','P','O','S','I','T','I','O','N', 
			   blr_parameter, 1, 6,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_225 */

static const short
   isc_236l = 229;
static const unsigned char
   isc_236 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 5,0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 2,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 13, 'R','D','B','$','F','U','N','C','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_or, 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_eql, 
			      blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			      blr_parameter, 0, 1,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','M','O','D','U','L','E','_','N','A','M','E', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 4,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 2,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_236 */

static const short
   isc_246l = 111;
static const unsigned char
   isc_246 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 11, 'R','D','B','$','F','I','L','T','E','R','S', 0, 
		  blr_sort, 1, 
		     blr_ascending, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_246 */

static const short
   isc_250l = 233;
static const unsigned char
   isc_250 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 6,0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 11, 'R','D','B','$','F','I','L','T','E','R','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','M','O','D','U','L','E','_','N','A','M','E', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 19, 'R','D','B','$','O','U','T','P','U','T','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','I','N','P','U','T','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 5,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 2,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_250 */

static const short
   isc_260l = 178;
static const unsigned char
   isc_260 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 3,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 2,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_260 */

static const short
   isc_267l = 921;
static const unsigned char
   isc_267 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 27,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 3,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 3, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 0, 
		     blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 1, 
		     blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 2, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			      blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_and, 
			      blr_eql, 
				 blr_field, 2, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
				 blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_or, 
				 blr_eql, 
				    blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
				    blr_parameter, 0, 0,0, 
				 blr_or, 
				    blr_eql, 
				       blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
				       blr_parameter, 0, 1,0, 
				    blr_and, 
				       blr_missing, 
					  blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
				       blr_eql, 
					  blr_field, 1, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
					  blr_parameter, 0, 2,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','B','L','R', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 1, 21, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 1, 19, 'R','D','B','$','C','O','M','P','U','T','E','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 8,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 9,0, 
			blr_assignment, 
			   blr_field, 2, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
			   blr_parameter2, 1, 10,0, 19,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 11,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 12,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 13,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 14,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 15,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 16,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 17,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 20,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 21,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 22,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','B','A','S','E','_','F','I','E','L','D', 
			   blr_parameter2, 1, 23,0, 18,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_parameter, 1, 24,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 25,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 26,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 11,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_267 */

static const short
   isc_300l = 128;
static const unsigned char
   isc_300 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 3,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_long, 0, 
	    blr_short, 0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','F','I','L','E','S', 0, 
		  blr_sort, 1, 
		     blr_ascending, 
			blr_field, 0, 14, 'R','D','B','$','F','I','L','E','_','S','T','A','R','T', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','F','I','L','E','_','N','A','M','E', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','L','E','_','S','T','A','R','T', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_300 */

static const short
   isc_305l = 200;
static const unsigned char
   isc_305 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 5,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','F','I','L','E','S', 0, 
		  blr_sort, 2, 
		     blr_ascending, 
			blr_field, 0, 17, 'R','D','B','$','S','H','A','D','O','W','_','N','U','M','B','E','R', 
		     blr_ascending, 
			blr_field, 0, 14, 'R','D','B','$','F','I','L','E','_','S','T','A','R','T', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','F','I','L','E','_','N','A','M','E', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','L','E','_','S','T','A','R','T', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','L','E','_','F','L','A','G','S', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','S','H','A','D','O','W','_','N','U','M','B','E','R', 
			blr_parameter, 0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_305 */

static const short
   isc_312l = 86;
static const unsigned char
   isc_312 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 2,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','D','A','T','A','B','A','S','E', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_312 */

static const short
   isc_316l = 115;
static const unsigned char
   isc_316 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 3,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','D','A','T','A','B','A','S','E', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter, 0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_316 */

static const short
   isc_321l = 148;
static const unsigned char
   isc_321 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 125,0, 
	 blr_message, 0, 1,0, 
	    blr_short, 0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 9, 'R','D','B','$','T','Y','P','E','S', 0, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			      blr_literal, blr_text, 18,0, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E',
			   blr_eql, 
			      blr_field, 0, 8, 'R','D','B','$','T','Y','P','E', 
			      blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','T','Y','P','E','_','N','A','M','E', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_321 */

static const short
   isc_327l = 170;
static const unsigned char
   isc_327 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 3,0, 
	    blr_long, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 125,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 20, 'R','D','B','$','F','I','E','L','D','_','D','I','M','E','N','S','I','O','N','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 13, 'R','D','B','$','D','I','M','E','N','S','I','O','N', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','P','P','E','R','_','B','O','U','N','D', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','L','O','W','E','R','_','B','O','U','N','D', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 2,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 2,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request isc_327 */


#define gds_blob_null	isc_blob_null	/* compatibility symbols */
#define gds_status	isc_status
#define gds_status2	isc_status2
#define gds_array_length	isc_array_length
#define gds_count	isc_count
#define gds_slack	isc_slack
#define gds_utility	isc_utility	/* end of compatibility symbols */

#ifndef isc_version4
    Generate a compile-time error.
    Picking up a V3 include file after preprocessing with V4 GPRE.
#endif

/**** end of GPRE definitions ****/


// values for rdb$trigger_type, based from types.h
// ** Some better way should be found to pick this up dynamically (?) **
// until then, this must be kept in sync with jrd/types.h manually.

const USHORT PRE_STORE		= 1;
const USHORT POST_STORE		= 2;
const USHORT PRE_MODIFY		= 3;
const USHORT POST_MODIFY	= 4;
const USHORT PRE_ERASE		= 5;
const USHORT POST_ERASE		= 6;

const int buf_len = 256;
typedef TEXT buf_type[buf_len];


void SHOW_stuff( qli_syntax* node)
{
/**************************************
 *
 *	S H O W _ s t u f f
 *
 **************************************
 *
 * Functional description
 *	Show various stuffs.
 *
 **************************************/
	qli_rel* relation;
	qli_dbb* dbb;
	USHORT count;
	qli_name* name;
	SSHORT width;

	QLI_skip_line = true;
	qli_syntax** ptr = node->syn_arg;

	for (USHORT i = 0; i < node->syn_count; i++)
	{
		const show_t sw = (enum show_t)(IPTR)*ptr++;
		qli_syntax* value = *ptr++;
		if (sw != show_matching_language && sw != show_version &&
			sw != show_variable && sw != show_variables && CMD_check_ready())
		{
			return;
		}

		switch (sw)
		{
		case show_all:
			for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
			{
				show_dbb(dbb);
				for (relation = dbb->dbb_relations; relation; relation = relation->rel_next)
				{
					if (!(relation->rel_flags & REL_system))
					{
						show_rel(relation);
						show_fields(relation, NULL);
					}
					if (QLI_abort)
						return;
				}
				printf("\n");
			}
			if (QLI_variables)
				show_vars();
			break;

		case show_databases:
			for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
			{
				show_dbb(dbb);
				show_dbb_parameters(dbb);
			}
			break;

		case show_database:
			if (!(dbb = (qli_dbb*) value))
				dbb = QLI_databases;
			show_dbb(dbb);
			show_dbb_parameters(dbb);
			for (relation = dbb->dbb_relations; relation; relation = relation->rel_next)
			{
				if (!(relation->rel_flags & REL_system))
				{
					show_rel(relation);
					show_fields(relation, NULL);
				}
			}
			printf("\n");
			break;

		case show_relations:
		case show_system_relations:
			// No need to define a buffer here; we are interested in its length.
			width = get_window_size(buf_len - 1);
			if (dbb = (qli_dbb*) value)
				show_rels(dbb, sw, width);
			else
			{
				for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
					show_rels(dbb, sw, width);
			}
			break;

		case show_db_fields:
			dbb = (qli_dbb*) value;
			for (relation = dbb->dbb_relations; relation; relation = relation->rel_next)
			{
				if (!(relation->rel_flags & REL_system))
				{
					show_rel(relation);
					show_fields(relation, NULL);
				}
				if (QLI_abort)
					return;
			}
			break;

		case show_security_classes:
			count = 0;
			if (value)
				count += show_security_classes_detail((qli_dbb*) value);
			else
			{
				for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
					count += show_security_classes_detail(dbb);
			}
			if (!count) {
				ERRQ_msg_put(90); // Msg90 No security classes defined
			}
			break;

		case show_security_class:
			count = 0;
			name = (qli_name*) value;
			for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
				count += show_security_class_detail(dbb, name->nam_string);
			if (!count) {
				ERRQ_msg_put(91, name->nam_string); // Msg91 Security class %s is not defined
			}
			break;

		case show_views:
			count = 0;
			if (value)
				count += show_views_detail((qli_dbb*) value);
			else
			{
				for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
					count += show_views_detail(dbb);
			}
			if (!count) {
				ERRQ_msg_put(92); // Msg92 No views defined
			}
			break;

		case show_relation:
			show_rel((qli_rel*) value);
			show_fields((qli_rel*) value, NULL);
			show_view((qli_rel*) value);
			show_rel_detail((qli_rel*) value);
			break;

		case show_indices:
			if (value)
			{
				show_rel((qli_rel*) value);
				if (!show_indices_detail((qli_rel*) value)) {
					ERRQ_msg_put(93); // Msg93 No indices defined
				}
				break;
			}
			for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
			{
				show_dbb(dbb);
				for (relation = dbb->dbb_relations; relation; relation = relation->rel_next)
				{
					if (!(relation->rel_flags & (REL_system | REL_view)))
					{
						show_rel(relation);
						if (!show_indices_detail(relation)) {
							ERRQ_msg_put(94); // Msg94 No indices defined
						}
					}
				}
			}
			break;

		case show_db_indices:
			dbb = (qli_dbb*) value;
			show_dbb(dbb);
			for (relation = dbb->dbb_relations; relation; relation = relation->rel_next)
			{
				if (!(relation->rel_flags & (REL_system | REL_view)))
				{
					show_rel(relation);
					if (!show_indices_detail(relation)) {
						ERRQ_msg_put(94); // Msg94 No indices defined
					}
				}
			}
			break;

		case show_field:
			show_fld(value);
			break;

		case show_filter:
			show_filt((qli_filter*) value);
			break;

		case show_filters:
			if (value)
				show_filts((qli_dbb*) value);
			else
			{
				for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
					show_filts(dbb);
			}
			break;

		case show_function:
			show_func((qli_func*) value);
			break;

		case show_functions:
			if (value)
				show_funcs((qli_dbb*) value);
			else
			{
				for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
					show_funcs(dbb);
			}
			break;

		case show_matching_language:
			show_matching();
			break;

		case show_procedures:
			if (value)
				show_procs((qli_dbb*) value);
			else
			{
				for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
					show_procs(dbb);
			}
			break;

		case show_procedure:
			show_proc((qli_proc*) value);
			break;

		case show_version:
			show_versions();
			break;

		case show_variable:
			show_var((qli_name*) value);
			break;

		case show_variables:
			show_vars();
			break;

		case show_global_field:
			show_gbl_field(value);
			break;

		case show_global_fields:
			show_gbl_fields((qli_dbb*) value);
			break;

		case show_trigger:
			show_trig((qli_rel*) value);
			break;

		case show_triggers:
			show_trigs((qli_dbb*) value);
			break;

		case show_system_triggers:
			if (value)
				show_sys_trigs((qli_dbb*) value);
			else
			{
				for (dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
					show_sys_trigs(dbb);
			}
			break;

		default:
			ERRQ_bugcheck(7);		// Msg7 show option not implemented
		}
	}
}


static void array_dimensions( qli_dbb* database, const TEXT* field_name)
{
   struct isc_330_struct {
          ISC_LONG isc_331;	/* RDB$UPPER_BOUND */
          ISC_LONG isc_332;	/* RDB$LOWER_BOUND */
          short isc_333;	/* isc_utility */
   } isc_330;
   struct isc_328_struct {
          char  isc_329 [125];	/* RDB$FIELD_NAME */
   } isc_328;
/**************************************
 *
 *	a r r a y _ d i m e n s i o n s
 *
 **************************************
 *
 * Functional description
 *	Display the dimensions of an array
 *
 **************************************/
	MET_meta_transaction(database, false);

	TEXT s[128], *p = s;
	s[0] = 0;

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_dimensions])
		D IN RDB$FIELD_DIMENSIONS WITH D.RDB$FIELD_NAME = field_name
			SORTED BY D.RDB$DIMENSION*/
	{
        if (!database->dbb_requests[REQ_show_dimensions])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_dimensions], (short) sizeof(isc_327), (char*) isc_327);
	isc_vtov ((const char*) field_name, (char*) isc_328.isc_329, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_dimensions], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_328, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_dimensions], (short) 1, (short) 10, &isc_330, (short) 0);
	   if (!isc_330.isc_333) break;

		if (/*D.RDB$LOWER_BOUND*/
		    isc_330.isc_332 != 1)
		{
			sprintf(p, "%" SLONGFORMAT":", /*D.RDB$LOWER_BOUND*/
						       isc_330.isc_332);
			while (*++p);
		}

		sprintf(p, "%" SLONGFORMAT", ", /*D.RDB$UPPER_BOUND*/
						isc_330.isc_331);
		while (*++p);
	/*END_FOR;*/
	   }
	}

	--p;
	*--p = 0;

	ERRQ_msg_partial(479, SafeArg() << s);	// Msg479 (%s)
}


static void display_acl( qli_dbb* dbb, ISC_QUAD& blob_id)
{
/**************************************
 *
 *	d i s p l a y _ a c l
 *
 **************************************
 *
 * Functional description
 *	Display the contents of a security class
 *
 **************************************/

	display_blob(dbb, blob_id, "\t    ", sizeof(acl_bpb), acl_bpb, true);
}


static void display_blob(qli_dbb* dbb,
						 ISC_QUAD& blob_id,
						 const TEXT* prefix,
						 USHORT bpb_length,
						 const UCHAR* bpb,
						 bool strip_line)
{
/**************************************
 *
 *	d i s p l a y _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Display the contents of a security class
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;

	UserBlob blob(status_vector);

	if (!blob.open(dbb->dbb_handle, dbb->dbb_meta_trans, blob_id, bpb_length, bpb))
	{
			ERRQ_database_error(dbb, status_vector);
	}

	buf_type buffer;
	const USHORT buffer_length = sizeof(buffer) - 1;
	for (;;)
	{
		FB_SIZE_T length;
		if (!blob.getSegment(buffer_length, buffer, length))
			break;
		buffer[length--] = 0;
		if (strip_line)
		{
			for (TEXT* b = buffer + length; b >= buffer;)
			{
				if (*b == '\n' || *b == '\t' || *b == ' ')
					*b-- = 0;
				else
					break;
			}
		}
		else
		{
			if (buffer[length] == '\n')
				buffer[length] = 0;
		}
		if (buffer[0])
			printf("%s%s\n", prefix, buffer);
	}

	blob.close();
}


static void display_blr( qli_dbb* dbb, ISC_QUAD& blob_id)
{
/**************************************
 *
 *	d i s p l a y _ b l r
 *
 **************************************
 *
 * Functional description
 *	Display the contents of a security class
 *
 **************************************/

	display_blob(dbb, blob_id, "\t    ", sizeof(blr_bpb), blr_bpb, true);
}


static void display_text( qli_dbb* dbb, ISC_QUAD& blob_id, const TEXT* prefix, bool strip)
{
/**************************************
 *
 *	d i s p l a y _ t e x t
 *
 **************************************
 *
 * Functional description
 *	Display a text blob.
 *
 **************************************/

	display_blob(dbb, blob_id, prefix, 0, NULL, strip);
}


static void display_procedure( qli_dbb* database, const UCHAR* name, FB_API_HANDLE blob)
{
/**************************************
 *
 *	d i s p l a y _ p r o c e d u r e
 *
 **************************************
 *
 * Functional description
 *	Show definition of procedure.  Somebody
 *	else has already figured out what database
 *	it's in, and so forth.
 *
 **************************************/
	ERRQ_msg_put(96, SafeArg() << name <<
				 database->dbb_filename << database->dbb_symbol->sym_string);
	// Msg96 Procedure %s in database %s (%s)

	TEXT buffer[256];
	while (PRO_get_line(blob, buffer, sizeof(buffer))) {
		printf("    %s", buffer);
	}

	PRO_close(database, blob);
	printf("\n");
}


static USHORT get_window_size( int max_width)
{
/**************************************
 *
 *	g e t _ w i n d o w _ s i z e
 *
 **************************************
 *
 * Functional description
 *	Get the display window size.
 *
 **************************************/
	SSHORT result = QLI_columns;

	if (max_width < result)
		result = max_width;
	return result;
}


static void show_blob_info(ISC_QUAD& blob_blr,
						   ISC_QUAD& blob_src,
						   USHORT msg_blr,
						   USHORT msg_src, qli_dbb* database,
						   const TEXT* relation_name)
{
/*****************************************************
 *
 *	s h o w _ b l o b _ i n f o
 *
 *****************************************************
 *
 * Functional description
 *	 Display source if possible or blr.
 *
 *****************************************************/

	if (UserBlob::blobIsNull(blob_src))
	{
		ERRQ_msg_put(msg_blr);
		display_blr(database, blob_blr);
	}
	else
	{
		ERRQ_msg_put(msg_src, relation_name);
		show_text_blob(database, "\t", 0, &blob_src, 0, NULL, true);
	}
}



static void show_blr(qli_dbb* database,
					 USHORT source_msg,
					 ISC_QUAD& source, USHORT blr_msg, ISC_QUAD& blr)
{
/**************************************
 *
 *	s h o w _ b l r
 *
 **************************************
 *
 * Functional description
 *	Show either source or blr for a blr item along with
 *	appopriate messages.
 *
 **************************************/

	if (!UserBlob::blobIsNull(source))
		show_text_blob(database, "\t", source_msg, &source, 0, NULL, false);
	else if (!UserBlob::blobIsNull(blr))
	{
		if (blr_msg)
			ERRQ_msg_put(blr_msg);
		display_blr(database, blr);
	}
}


static void show_datatype(qli_dbb* database,
						  USHORT dtype,
						  USHORT length,
						  SSHORT scale,
						  SSHORT sub_type,
						  USHORT segment_length,
						  USHORT dimensions)
{
   struct isc_324_struct {
          short isc_325;	/* isc_utility */
          char  isc_326 [125];	/* RDB$TYPE_NAME */
   } isc_324;
   struct isc_322_struct {
          short isc_323;	/* RDB$TYPE */
   } isc_322;
/**************************************
 *
 *	s h o w _ d a t a t y p e
 *
 **************************************
 *
 * Functional description
 *	Display datatype information.
 *
 **************************************/
	TEXT subtype[32];
	SSHORT msg = 0;

	switch (dtype)
	{
	case dtype_text:
		msg = 97;
		break;

	case dtype_varying:
		msg = 98;
		break;

	case dtype_cstring:
		length -= 1;
		msg = 99;
		break;

	case dtype_short:
		msg = 100;
		break;

	case dtype_long:
		msg = 101;
		break;

	case dtype_quad:
		msg = 102;
		break;

	case dtype_real:
		msg = 103;
		break;

	case dtype_double:
		msg = 104;
		break;

	case dtype_int64:
		msg = 329;
		break;

	case dtype_blob:
		ERRQ_msg_partial(105);	// Msg105 blob
		if (segment_length) {
			ERRQ_msg_partial(106, SafeArg() << segment_length);	// Msg106 , segment length %d
		}
		if (sub_type)
		{
			// Only the number in case there's no text name for the type.
			sprintf(subtype, "%d", sub_type);
			if (database && (database->dbb_capabilities & DBB_cap_types))
			{
				/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_fld_subtype])
					TYPE IN RDB$TYPES WITH TYPE.RDB$FIELD_NAME EQ "RDB$FIELD_SUB_TYPE"
					AND TYPE.RDB$TYPE EQ sub_type*/
				{
                                if (!database->dbb_requests[REQ_fld_subtype])
                                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_fld_subtype], (short) sizeof(isc_321), (char*) isc_321);
				isc_322.isc_323 = sub_type;
                                isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_fld_subtype], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 2, &isc_322, (short) 0);
				while (1)
				   {
                                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_fld_subtype], (short) 1, (short) 127, &isc_324, (short) 0);
				   if (!isc_324.isc_325) break;

					TEXT* p = subtype;
					for (const TEXT* q = /*TYPE.RDB$TYPE_NAME*/
							     isc_324.isc_326; *q && *q != ' ';) {
						*p++ = *q++;
					}
					*p = 0;
				/*END_FOR;*/
				   }
				}
			}
			ERRQ_msg_partial(107, SafeArg() << subtype);
		}
		return;

	case dtype_sql_date:
		ERRQ_msg_partial(110, SafeArg() << length);
		ERRQ_msg_partial(107, SafeArg() << "SQL DATE");
		return;

	case dtype_sql_time:
		ERRQ_msg_partial(110, SafeArg() << length);
		ERRQ_msg_partial(107, SafeArg() << "SQL TIME");
		return;

	case dtype_timestamp:
		msg = 110;
		break;

	default:
		ERRQ_bugcheck(8);			// Msg8 show_fields: dtype not done
	}

	ERRQ_msg_partial(msg, SafeArg() << length);

	if (dimensions) {
		ERRQ_msg_partial(433);	// Msg433  array
	}

	switch (dtype)
	{
	case dtype_short:
	case dtype_long:
	case dtype_quad:
	case dtype_int64:
		if (scale) {
			ERRQ_msg_partial(111, SafeArg() << scale); // Msg111 , scale %d
		}
		break;
	case dtype_text:
	case dtype_varying:
	case dtype_cstring:
		if (sub_type == 1)
			ERRQ_msg_partial(112);	// Msg112 , subtype fixed
		else if (sub_type != 0)
		{
			sprintf(subtype, "%d", sub_type);
			ERRQ_msg_partial(107, SafeArg() << subtype);
		}
		break;
	}
}


static void show_dbb( qli_dbb* database)
{
/**************************************
 *
 *	s h o w _ d b b
 *
 **************************************
 *
 * Functional description
 *	Print a database name and some
 *	functional stuff about it.
 *
 **************************************/
	if (database)
	{
		const qli_symbol* symbol = database->dbb_symbol;
		if (symbol)
		{
			ERRQ_msg_put(113, SafeArg() << database->dbb_filename << symbol->sym_string);
			// Msg113 Database %s readied as %s
		}
		else
			ERRQ_msg_put(114, database->dbb_filename);	// Msg114 Database %s
	}
	else
		ERRQ_msg_put(115);	// Msg115 No databases are currently ready
}


static void show_dbb_parameters( qli_dbb* database)
{
   struct isc_301_struct {
          char  isc_302 [256];	/* RDB$FILE_NAME */
          ISC_LONG isc_303;	/* RDB$FILE_START */
          short isc_304;	/* isc_utility */
   } isc_301;
   struct isc_306_struct {
          char  isc_307 [256];	/* RDB$FILE_NAME */
          ISC_LONG isc_308;	/* RDB$FILE_START */
          short isc_309;	/* isc_utility */
          short isc_310;	/* RDB$FILE_FLAGS */
          short isc_311;	/* RDB$SHADOW_NUMBER */
   } isc_306;
   struct isc_313_struct {
          ISC_QUAD isc_314;	/* RDB$DESCRIPTION */
          short isc_315;	/* isc_utility */
   } isc_313;
   struct isc_317_struct {
          ISC_QUAD isc_318;	/* RDB$DESCRIPTION */
          short isc_319;	/* isc_utility */
          char  isc_320 [125];	/* RDB$SECURITY_CLASS */
   } isc_317;
/**************************************
 *
 *	s h o w _ d b b _ p a r a m e t e r s
 *
 **************************************
 *
 * Functional description
 *	Print stuff about a database.
 *
 **************************************/
	UCHAR buffer[127];
	ISC_STATUS_ARRAY status_vector;

	if (!database)
		return;

	if (isc_database_info(status_vector, &database->dbb_handle,
						   sizeof(db_items), db_items, sizeof(buffer), (char*) buffer))
	{
		ERRQ_database_error(database, status_vector);
	}

	SLONG page_size = 0, allocation = 0;

	for (const UCHAR* d = buffer; *d != isc_info_end;)
	{
		const UCHAR item = *d++;
		const SLONG length = gds__vax_integer(d, 2);
		d += 2;

		switch (item)
		{
		case isc_info_db_size_in_pages:
			allocation = gds__vax_integer(d, length);
			break;

		case isc_info_page_size:
			page_size = gds__vax_integer(d, length);
			break;

		case isc_info_error:
			break;
		}
		d += length;
	}

	ERRQ_msg_put(116, SafeArg() << page_size << allocation);
	// Msg116 Page size is %d bytes.  Current allocation is %d pages.

	MET_meta_transaction(database, false);

	if (database->dbb_capabilities & DBB_cap_security)
	{
		/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_dbb])
			D IN RDB$DATABASE*/
		{
                if (!database->dbb_requests[REQ_show_dbb])
                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_dbb], (short) sizeof(isc_316), (char*) isc_316);
                isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_dbb], (FB_API_HANDLE*) &gds_trans, (short) 0);
		while (1)
		   {
                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_dbb], (short) 0, (short) 135, &isc_317, (short) 0);
		   if (!isc_317.isc_319) break;
			show_string(260, /*D.RDB$SECURITY_CLASS*/
					 isc_317.isc_320, 0, NULL);
			show_text_blob(database, "\t", 261, &/*D.RDB$DESCRIPTION*/
							     isc_317.isc_318, 0, NULL, false);
		/*END_FOR;*/
		   }
		}
	}
	else
	{
		/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_dbb])
			D IN RDB$DATABASE*/
		{
                if (!database->dbb_requests[REQ_show_dbb])
                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_dbb], (short) sizeof(isc_312), (char*) isc_312);
                isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_dbb], (FB_API_HANDLE*) &gds_trans, (short) 0);
		while (1)
		   {
                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_dbb], (short) 0, (short) 10, &isc_313, (short) 0);
		   if (!isc_313.isc_315) break;
			show_text_blob(database, "\t", 262, &/*D.RDB$DESCRIPTION*/
							     isc_313.isc_314, 0, NULL, false);
		/*END_FOR;*/
		   }
		}
	}

	if (database->dbb_capabilities & DBB_cap_files)
	{
		if (database->dbb_capabilities & DBB_cap_shadowing)
		{
			/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_files])
				F IN DB.RDB$FILES SORTED BY F.RDB$SHADOW_NUMBER, F.RDB$FILE_START*/
			{
                        if (!database->dbb_requests[REQ_show_files])
                           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_files], (short) sizeof(isc_305), (char*) isc_305);
                        isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_files], (FB_API_HANDLE*) &gds_trans, (short) 0);
			while (1)
			   {
                           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_files], (short) 0, (short) 266, &isc_306, (short) 0);
			   if (!isc_306.isc_309) break;

				if (/*F.RDB$SHADOW_NUMBER*/
				    isc_306.isc_311)
				{
					if (!(/*F.RDB$FILE_FLAGS*/
					      isc_306.isc_310 & FILE_conditional))
					{
						ERRQ_msg_put(385, SafeArg() << /*F.RDB$SHADOW_NUMBER*/
									       isc_306.isc_311 <<
										/*F.RDB$FILE_NAME*/
										isc_306.isc_307 << /*F.RDB$FILE_START*/
    isc_306.isc_308);
						// Msg385 Shadow %d, File:%s starting at page %d
					}
				}
				else
				{
					ERRQ_msg_put(263, SafeArg() << /*F.RDB$FILE_NAME*/
								       isc_306.isc_307 << /*F.RDB$FILE_START*/
    isc_306.isc_308);
						// Msg263 File:%s starting at page %d
			 	}
			/*END_FOR;*/
			   }
			}
		}
		else
		{
			/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_files])
				F IN DB.RDB$FILES SORTED BY F.RDB$FILE_START*/
			{
                        if (!database->dbb_requests[REQ_show_files])
                           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_files], (short) sizeof(isc_300), (char*) isc_300);
                        isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_files], (FB_API_HANDLE*) &gds_trans, (short) 0);
			while (1)
			   {
                           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_files], (short) 0, (short) 262, &isc_301, (short) 0);
			   if (!isc_301.isc_304) break;

				ERRQ_msg_put(263, SafeArg() << /*F.RDB$FILE_NAME*/
							       isc_301.isc_302 << /*F.RDB$FILE_START*/
    isc_301.isc_303);
				// Msg263 File:%s starting at page %d
			/*END_FOR;*/
			   }
			}
		}
	}
}


static int show_field_detail(qli_dbb* database,
							 const TEXT* relation_name,
							 const TEXT* field_name,
							 qli_syntax* idx_node)
{
   struct isc_272_struct {
          ISC_QUAD isc_273;	/* RDB$QUERY_HEADER */
          ISC_QUAD isc_274;	/* RDB$QUERY_HEADER */
          char  isc_275 [128];	/* RDB$EDIT_STRING */
          char  isc_276 [128];	/* RDB$EDIT_STRING */
          ISC_QUAD isc_277;	/* RDB$VALIDATION_BLR */
          ISC_QUAD isc_278;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD isc_279;	/* RDB$COMPUTED_BLR */
          ISC_QUAD isc_280;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD isc_281;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_282;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_283;	/* RDB$VIEW_BLR */
          short isc_284;	/* isc_utility */
          short isc_285;	/* RDB$SEGMENT_LENGTH */
          short isc_286;	/* RDB$FIELD_SUB_TYPE */
          short isc_287;	/* RDB$FIELD_SCALE */
          short isc_288;	/* RDB$FIELD_LENGTH */
          short isc_289;	/* RDB$FIELD_TYPE */
          short isc_290;	/* RDB$VIEW_CONTEXT */
          short isc_291;	/* gds__null_flag */
          short isc_292;	/* gds__null_flag */
          char  isc_293 [125];	/* RDB$RELATION_NAME */
          char  isc_294 [125];	/* RDB$FIELD_NAME */
          char  isc_295 [125];	/* RDB$FIELD_NAME */
          char  isc_296 [125];	/* RDB$BASE_FIELD */
          char  isc_297 [125];	/* RDB$SECURITY_CLASS */
          char  isc_298 [125];	/* RDB$QUERY_NAME */
          char  isc_299 [125];	/* RDB$QUERY_NAME */
   } isc_272;
   struct isc_268_struct {
          char  isc_269 [125];	/* RDB$FIELD_NAME */
          char  isc_270 [125];	/* RDB$QUERY_NAME */
          char  isc_271 [125];	/* RDB$QUERY_NAME */
   } isc_268;
/**************************************
 *
 *	s h o w _ f i e l d _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show everything we know about local
 *	fields with the specified name in a particular
 *	database.
 *
 **************************************/
	MET_meta_transaction(database, false);
	USHORT count = 0;

	if (!(database->dbb_capabilities & DBB_cap_security))
		count += show_insecure_fields(database, relation_name, field_name);

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_field])
		RFR IN RDB$RELATION_FIELDS CROSS
			F IN RDB$FIELDS CROSS
			R IN RDB$RELATIONS WITH
			RFR.RDB$FIELD_SOURCE = F.RDB$FIELD_NAME AND
			R.RDB$RELATION_NAME = RFR.RDB$RELATION_NAME AND
			(RFR.RDB$FIELD_NAME = field_name OR
			 RFR.RDB$QUERY_NAME = field_name OR
			 (RFR.RDB$QUERY_NAME MISSING AND F.RDB$QUERY_NAME = field_name))*/
	{
        if (!database->dbb_requests[REQ_show_field])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_field], (short) sizeof(isc_267), (char*) isc_267);
	isc_vtov ((const char*) field_name, (char*) isc_268.isc_269, 125);
	isc_vtov ((const char*) field_name, (char*) isc_268.isc_270, 125);
	isc_vtov ((const char*) field_name, (char*) isc_268.isc_271, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_field], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 375, &isc_268, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_field], (short) 1, (short) 1221, &isc_272, (short) 0);
	   if (!isc_272.isc_284) break;

		fb_utils::exact_name(/*RFR.RDB$RELATION_NAME*/
				     isc_272.isc_293);

		if (relation_name && (strcmp(/*RFR.RDB$RELATION_NAME*/
					     isc_272.isc_293, relation_name)))
			continue;

		const USHORT dimensions = MET_dimensions(database, /*F.RDB$FIELD_NAME*/
								   isc_272.isc_294);
		if (dimensions && idx_node && dimensions != idx_node->syn_arg[s_idx_count]->syn_count)
		{
			continue;
		}

		if (count++)
			printf("\n");

		fb_utils::exact_name(/*RFR.RDB$FIELD_NAME*/
				     isc_272.isc_295);
		fb_utils::exact_name(/*F.RDB$FIELD_NAME*/
				     isc_272.isc_294);

		if (!/*R.RDB$VIEW_BLR.NULL*/
		     isc_272.isc_292)
		{
			ERRQ_msg_put(495, SafeArg() << /*RFR.RDB$FIELD_NAME*/
						       isc_272.isc_295 << /*RFR.RDB$RELATION_NAME*/
    isc_272.isc_293 <<
						 database->dbb_symbol->sym_string);
			// Msg495 Field %s in view %s of database %s
		}
		else
		{
			ERRQ_msg_put(496, SafeArg() << /*RFR.RDB$FIELD_NAME*/
						       isc_272.isc_295 << /*RFR.RDB$RELATION_NAME*/
    isc_272.isc_293 <<
						 database->dbb_symbol->sym_string);
			// Msg495 Field %s in relation %s of database %s
		}
		ERRQ_msg_put(265, /*F.RDB$FIELD_NAME*/
				  isc_272.isc_294);
		// Msg265 Global field %s

		if (!/*RFR.RDB$BASE_FIELD.NULL*/
		     isc_272.isc_291)
		{
			fb_utils::exact_name(/*RFR.RDB$BASE_FIELD*/
					     isc_272.isc_296);
			view_info(database, /*RFR.RDB$RELATION_NAME*/
					    isc_272.isc_293, /*RFR.RDB$BASE_FIELD*/
  isc_272.isc_296, /*RFR.RDB$VIEW_CONTEXT*/
  isc_272.isc_290, 0);
		}

		show_text_blob(database, "\t", 266, &/*RFR.RDB$DESCRIPTION*/
						     isc_272.isc_282, 339, &/*F.RDB$DESCRIPTION*/
	isc_272.isc_281, false);
		ERRQ_msg_put(267);
		// Msg267 Datatype information:
		printf("\t");

		show_datatype(database, MET_get_datatype(/*F.RDB$FIELD_TYPE*/
							 isc_272.isc_289), /*F.RDB$FIELD_LENGTH*/
   isc_272.isc_288,
						/*F.RDB$FIELD_SCALE*/
						isc_272.isc_287, /*F.RDB$FIELD_SUB_TYPE*/
  isc_272.isc_286, /*F.RDB$SEGMENT_LENGTH*/
  isc_272.isc_285, dimensions);
		if (dimensions && !idx_node)
			array_dimensions(database, /*F.RDB$FIELD_NAME*/
						   isc_272.isc_294);
		printf("\n");
		show_blr(database, 341, /*F.RDB$COMPUTED_SOURCE*/
					isc_272.isc_280, 341, /*F.RDB$COMPUTED_BLR*/
       isc_272.isc_279);
		show_blr(database, 342, /*F.RDB$VALIDATION_SOURCE*/
					isc_272.isc_278, 342, /*F.RDB$VALIDATION_BLR*/
       isc_272.isc_277);
		show_string(270, /*RFR.RDB$SECURITY_CLASS*/
				 isc_272.isc_297, 0, NULL);
		show_string(271, /*RFR.RDB$QUERY_NAME*/
				 isc_272.isc_298, 271, /*F.RDB$QUERY_NAME*/
       isc_272.isc_299);
		show_string(273, /*RFR.RDB$EDIT_STRING*/
				 isc_272.isc_276, 273, /*F.RDB$EDIT_STRING*/
       isc_272.isc_275);
		show_text_blob(database, "\t", 275, &/*RFR.RDB$QUERY_HEADER*/
						     isc_272.isc_274, 275, &/*F.RDB$QUERY_HEADER*/
	isc_272.isc_273, false);
	/*END_FOR;*/
	   }
	}

	return count;
}


static int show_field_instances( qli_dbb* database, const TEXT* field_name)
{
   struct isc_263_struct {
          short isc_264;	/* isc_utility */
          char  isc_265 [125];	/* RDB$FIELD_NAME */
          char  isc_266 [125];	/* RDB$RELATION_NAME */
   } isc_263;
   struct isc_261_struct {
          char  isc_262 [125];	/* RDB$FIELD_SOURCE */
   } isc_261;
/**************************************
 *
 *	s h o w _ f i e l d _ i n s t a n c e s
 *
 **************************************
 *
 * Functional description
 *	Print a list of places where a global field
 *	is used.
 *
 **************************************/
	int count = 0;

	MET_meta_transaction(database, false);

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_field_instance])
		RFR IN RDB$RELATION_FIELDS WITH RFR.RDB$FIELD_SOURCE = field_name
			SORTED BY RFR.RDB$RELATION_NAME*/
	{
        if (!database->dbb_requests[REQ_show_field_instance])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_field_instance], (short) sizeof(isc_260), (char*) isc_260);
	isc_vtov ((const char*) field_name, (char*) isc_261.isc_262, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_field_instance], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_261, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_field_instance], (short) 1, (short) 252, &isc_263, (short) 0);
	   if (!isc_263.isc_264) break;

		if (!count++)
		{
			ERRQ_msg_put(335, SafeArg() << field_name << database->dbb_symbol->sym_string);
			// Msg335 Global field %s is used database %s as:
		}
		fb_utils::exact_name(/*RFR.RDB$FIELD_NAME*/
				     isc_263.isc_265);
		fb_utils::exact_name(/*RFR.RDB$RELATION_NAME*/
				     isc_263.isc_266);
		ERRQ_msg_put(336, SafeArg() << /*RFR.RDB$FIELD_NAME*/
					       isc_263.isc_265 << /*RFR.RDB$RELATION_NAME*/
    isc_263.isc_266);
		// Msg336 %s in relation %s
	/*END_FOR;*/
	   }
	}

	return count;
}


static void show_fields( qli_rel* relation, qli_fld* fields)
{
/**************************************
 *
 *	s h o w _ f i e l d s
 *
 **************************************
 *
 * Functional description
 *	Show the fields for a relation.
 *
 **************************************/
	qli_dbb* database;

	// Find the long field name (including query name)

	if (relation)
	{
		if (!(relation->rel_flags & REL_fields))
			MET_fields(relation);
		fields = relation->rel_fields;
		database = relation->rel_database;
		MET_meta_transaction(database, false);
	}
	else
		database = NULL;

	USHORT max_name = 0;
	const qli_fld* field;

	for (field = fields; field; field = field->fld_next)
	{
		USHORT l = field->fld_name->sym_length;
		const qli_symbol* symbol = field->fld_query_name;
		if (symbol)
			l += symbol->sym_length + 3;
		max_name = MAX(max_name, l);
	}

	// Now print the fields

	for (field = fields; field; field = field->fld_next)
	{
		if (QLI_abort)
			return;

		const qli_symbol* symbol = field->fld_name;
		USHORT l = symbol->sym_length;
		printf("        %s", symbol->sym_string);

		if (symbol = field->fld_query_name)
		{
			l += symbol->sym_length + 3;
			printf(" (%s)", symbol->sym_string);
		}

		for (l = max_name + 12 - l; l; --l)
			putchar(' ');
		show_datatype(database, field->fld_dtype,
					  (field->fld_dtype == dtype_varying) ? field->fld_length - 2 : field->fld_length,
					  field->fld_scale, field->fld_sub_type, field->fld_segment_length,
					  (field->fld_flags & FLD_array) ? 1 : 0);
		if (database && field->fld_flags & FLD_array)
			array_dimensions(database, field->fld_name->sym_string);
		if (field->fld_flags & FLD_computed)
			ERRQ_msg_put(119);	// Msg119 (computed expression)
		else
			printf("\n");
	}
}


static void show_filt( qli_filter* filter)
{
/**************************************
 *
 *	s h o w _ f i l t
 *
 **************************************
 *
 * Functional description
 *	Show definition of filter.  If a particular database
 *	was specified, look there, otherwise, print all filters
 *	with that name.
 *
 **************************************/
	int count = 0;
	const qli_name* name = filter->qfl_name;

	qli_dbb* database = filter->qfl_database;
	if (database)
	{
		if (!(database->dbb_capabilities & DBB_cap_filters))
		{
			// Msg439 Filters are not supported in database %s.
			ERRQ_msg_put(439, database->dbb_symbol->sym_string);
			return;
		}
		count = show_filter_detail(database, name->nam_string);
		if (!count)
		{
			// Msg440 Filter %s is not defined in database %s.
			ERRQ_msg_put(440, SafeArg() << name->nam_string << database->dbb_symbol->sym_string);
		}
	}
	else
	{
		bool any_supported = false;
		for (database = QLI_databases; database; database = database->dbb_next)
		{
			if (database->dbb_capabilities & DBB_cap_filters)
			{
				any_supported = true;
				count += show_filter_detail(database, name->nam_string);
			}
		}
		if (!count)
		{
			if (any_supported)
			{
				// Msg441 Filter %s is not defined in any open database
				ERRQ_msg_put(441, name->nam_string);
			}
			else
			{
				// Msg442 Filters are not supported in any open database.
				ERRQ_msg_put(442);
			}
		}
	}
}


static int show_filter_detail( qli_dbb* database, const TEXT* filter_name)
{
   struct isc_253_struct {
          ISC_QUAD isc_254;	/* RDB$DESCRIPTION */
          char  isc_255 [256];	/* RDB$MODULE_NAME */
          short isc_256;	/* isc_utility */
          short isc_257;	/* RDB$OUTPUT_SUB_TYPE */
          short isc_258;	/* RDB$INPUT_SUB_TYPE */
          char  isc_259 [125];	/* RDB$FUNCTION_NAME */
   } isc_253;
   struct isc_251_struct {
          char  isc_252 [125];	/* RDB$FUNCTION_NAME */
   } isc_251;
/**************************************
 *
 *	s h o w _ f i l t e r _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Display the following information about a
 *	filter with the specified name in a particular
 *	database:  Filter name, filter library, input and
 *	output sub-types, and description.
 *
 **************************************/
	MET_meta_transaction(database, false);

	int count = 0;

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_filter_detail])
		F IN RDB$FILTERS WITH F.RDB$FUNCTION_NAME = filter_name*/
	{
        if (!database->dbb_requests[REQ_show_filter_detail])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_filter_detail], (short) sizeof(isc_250), (char*) isc_250);
	isc_vtov ((const char*) filter_name, (char*) isc_251.isc_252, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_filter_detail], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_251, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_filter_detail], (short) 1, (short) 395, &isc_253, (short) 0);
	   if (!isc_253.isc_256) break;

		count++;
		fb_utils::exact_name(/*F.RDB$FUNCTION_NAME*/
				     isc_253.isc_259);

		ERRQ_msg_put(444,		// Msg444 Filter %s in database \"%s\" (%s):
					 SafeArg() << /*F.RDB$FUNCTION_NAME*/
						      isc_253.isc_259 << database->dbb_filename <<
					 database->dbb_symbol->sym_string);
		ERRQ_msg_put(445, /*F.RDB$MODULE_NAME*/
				  isc_253.isc_255); // Msg445 Filter library is %s
		ERRQ_msg_put(446, SafeArg() << /*F.RDB$INPUT_SUB_TYPE*/
					       isc_253.isc_258);	// Msg446 Input sub-type is %d
		ERRQ_msg_put(447, SafeArg() << /*F.RDB$OUTPUT_SUB_TYPE*/
					       isc_253.isc_257);	// Msg447 Output sub-type is %d
		show_text_blob(database, "\t", 448, &/*F.RDB$DESCRIPTION*/
						     isc_253.isc_254, 0, NULL, false);
	/*END_FOR;*/
	   }
	}
	return count;
}


static void show_filts( qli_dbb* database)
{
/**************************************
 *
 *	s h o w _ f i l t s
 *
 * Functional description
 *	Show filter names in a database.
 *
 **************************************/

	if (!(database->dbb_capabilities & DBB_cap_filters))
	{
		// Msg463 Filters are not supported for database %s.
		ERRQ_msg_put(463, database->dbb_symbol->sym_string);
	}
	else if (!(show_filters_detail(database)))
	{
		// Msg464 no filters defined for database %s.
		ERRQ_msg_put(464, database->dbb_symbol->sym_string);
	}
}


static int show_filters_detail( qli_dbb* database)
{
   struct isc_247_struct {
          short isc_248;	/* isc_utility */
          char  isc_249 [125];	/* RDB$FUNCTION_NAME */
   } isc_247;
/**************************************
 *
 *	s h o w _ f i l t e r s _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show filter names in a database.
 *
 **************************************/
	buf_type buffer;
	SSHORT width = get_window_size(sizeof(buffer) - 1);
	buffer[0] = 0;

	MET_meta_transaction(database, false);

	int count = 0;
	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_filters])
		F IN RDB$FILTERS
		SORTED BY F.RDB$FUNCTION_NAME*/
	{
        if (!database->dbb_requests[REQ_show_filters])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_filters], (short) sizeof(isc_246), (char*) isc_246);
        isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_filters], (FB_API_HANDLE*) &gds_trans, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_filters], (short) 0, (short) 127, &isc_247, (short) 0);
	   if (!isc_247.isc_248) break;

		if (!count++)
		{
			ERRQ_msg_put(449, SafeArg() << database->dbb_filename <<
						   database->dbb_symbol->sym_string);
			// Msg449 Filters in database %s (%s):
		}
		show_names(/*F.RDB$FUNCTION_NAME*/
			   isc_247.isc_249, width, buffer);
	/*END_FOR;*/
	   }
	}

	if (buffer[0])
		printf("%s\n", buffer);

	return count;
}


static void show_fld( qli_syntax* field_node)
{
/**************************************
 *
 *	s h o w _ f l d
 *
 **************************************
 *
 * Functional description
 *	Show all details about a particular
 *	field.  What we've got coming in
 *	is a list of 1, 2, or 3 name blocks,
 *	contain the [[database.]relation.]field
 *	specification.  Figure out what we've
 *	got and let somebody else do all the work.
 *
 **************************************/
	qli_syntax* idx_node = NULL;

	if (field_node->syn_type == nod_index)
	{
		idx_node = field_node;
		field_node = idx_node->syn_arg[s_idx_field];
	}

	qli_dbb* database = NULL;
	qli_name* field_name = NULL;
	qli_name* relation_name = NULL;
	for (qli_syntax** ptr = field_node->syn_arg + field_node->syn_count;
		--ptr >= field_node->syn_arg;)
	{
		if (!field_name)
			field_name = (qli_name*) * ptr;
		else if (!relation_name)
			relation_name = (qli_name*) * ptr;
		else
			for (qli_symbol* symbol = ((qli_name*) *ptr)->nam_symbol; symbol; symbol = symbol->sym_homonym)
			{
				if (symbol->sym_type == SYM_database)
				{
					database = (qli_dbb*) symbol->sym_object;
					break;
				}
			}
	}

	const TEXT* string = relation_name ? relation_name->nam_string : NULL;
	TEXT s[65];

	if (string)
		sprintf(s, "%s.%s", string, field_name->nam_string);
	else
		sprintf(s, "%s", field_name->nam_string);

	int count = 0;
	if (database)
	{
		count += show_field_detail(database, string, field_name->nam_string, NULL);
		if (!count)
		{
			ERRQ_msg_put(117, SafeArg() << s << database->dbb_symbol->sym_string);
			// Msg117 Field %s does not exist in database %s
		}
	}
	else
	{
		for (database = QLI_databases; database; database = database->dbb_next)
		{
			count += show_field_detail(database, string, field_name->nam_string, idx_node);
		}
		if (!count) {
			ERRQ_msg_put(118, s); // Msg118 Field %s does not exist in any open database
		}
	}
}


static void show_func( qli_func* func)
{
/**************************************
 *
 *	s h o w _ f u n c
 *
 **************************************
 *
 * Functional description
 *	Show definition of function.  If a particular database
 *	was specified, look there, otherwise, print all functions
 *	with that name.
 *
 **************************************/
	int count = 0;
	const qli_name* name = func->qfn_name;

	qli_dbb* database = func->qfn_database;
	if (database)
	{
		if (!(database->dbb_capabilities & DBB_cap_functions))
		{
			// Msg417 Functions are not supported in database %s.
			ERRQ_msg_put(417, database->dbb_symbol->sym_string);
			return;
		}
		count = show_func_detail(database, name->nam_string);
		if (!count)
		{
			// Msg422 Function %s is not defined in database %s.
			ERRQ_msg_put(422, SafeArg() << name->nam_string << database->dbb_symbol->sym_string);
		}
	}
	else
	{
		bool any_supported = false;
		for (database = QLI_databases; database; database = database->dbb_next)
		{
			if (database->dbb_capabilities & DBB_cap_functions)
			{
				any_supported = true;
				count += show_func_detail(database, name->nam_string);
			}
		}
		if (!count)
		{
			if (any_supported)
			{
				// Msg423 Function is %s not defined in any open database
				ERRQ_msg_put(423, name->nam_string);
			}
			else {
				ERRQ_msg_put(420); // Msg420 Functions are not supported in any open database.
			}
		}
	}
}


static int show_func_detail( qli_dbb* database, const TEXT* func_name)
{
   struct isc_228_struct {
          short isc_229;	/* isc_utility */
          short isc_230;	/* RDB$FIELD_SUB_TYPE */
          short isc_231;	/* RDB$FIELD_SCALE */
          short isc_232;	/* RDB$FIELD_LENGTH */
          short isc_233;	/* RDB$FIELD_TYPE */
          short isc_234;	/* RDB$MECHANISM */
          short isc_235;	/* RDB$ARGUMENT_POSITION */
   } isc_228;
   struct isc_226_struct {
          char  isc_227 [125];	/* RDB$FUNCTION_NAME */
   } isc_226;
   struct isc_240_struct {
          ISC_QUAD isc_241;	/* RDB$DESCRIPTION */
          char  isc_242 [256];	/* RDB$MODULE_NAME */
          short isc_243;	/* isc_utility */
          char  isc_244 [125];	/* RDB$QUERY_NAME */
          char  isc_245 [125];	/* RDB$FUNCTION_NAME */
   } isc_240;
   struct isc_237_struct {
          char  isc_238 [125];	/* RDB$FUNCTION_NAME */
          char  isc_239 [125];	/* RDB$QUERY_NAME */
   } isc_237;
/**************************************
 *
 *	s h o w _ f u n c _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Display the following information about a
 *	function with the specified name in a particular
 *	database:  Function name, query name, function
 *	library, input and output argument datatypes, and
 *	description.
 *
 **************************************/

	MET_meta_transaction(database, false);
	int count = 0;

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_func_detail])
		F IN RDB$FUNCTIONS WITH
			(F.RDB$FUNCTION_NAME = func_name OR F.RDB$QUERY_NAME = func_name)*/
	{
        if (!database->dbb_requests[REQ_show_func_detail])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_func_detail], (short) sizeof(isc_236), (char*) isc_236);
	isc_vtov ((const char*) func_name, (char*) isc_237.isc_238, 125);
	isc_vtov ((const char*) func_name, (char*) isc_237.isc_239, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_func_detail], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 250, &isc_237, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_func_detail], (short) 1, (short) 516, &isc_240, (short) 0);
	   if (!isc_240.isc_243) break;
		count++;
		fb_utils::exact_name(/*F.RDB$QUERY_NAME*/
				     isc_240.isc_244);
		fb_utils::exact_name(/*F.RDB$FUNCTION_NAME*/
				     isc_240.isc_245);

		/*BASED ON RDB$FUNCTIONS.RDB$QUERY_NAME fq_name;*/
		char
		   fq_name[125];

		strcpy(fq_name, /*F.RDB$FUNCTION_NAME*/
				isc_240.isc_245);

		if (/*F.RDB$QUERY_NAME*/
		    isc_240.isc_244[0])
		{
			ERRQ_msg_put(424,	// Msg424 Function %s (%s) in database \"%s\" (%s):
						 SafeArg() << /*F.RDB$FUNCTION_NAME*/
							      isc_240.isc_245 << /*F.RDB$QUERY_NAME*/
    isc_240.isc_244 <<
						 database->dbb_filename << database->dbb_symbol->sym_string);
		}
		else
		{
			ERRQ_msg_put(425,	// Msg425 Function %s in database \"%s\" (%s):
						 SafeArg() << /*F.RDB$FUNCTION_NAME*/
							      isc_240.isc_245 << database->dbb_filename <<
						 database->dbb_symbol->sym_string);
		}

		ERRQ_msg_put(426, /*F.RDB$MODULE_NAME*/
				  isc_240.isc_242);
		// Msg426 Function library is %s

		/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_func_args])
			FA IN RDB$FUNCTION_ARGUMENTS WITH
				FA.RDB$FUNCTION_NAME = fq_name SORTED BY FA.RDB$ARGUMENT_POSITION*/
		{
                if (!database->dbb_requests[REQ_show_func_args])
                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_func_args], (short) sizeof(isc_225), (char*) isc_225);
		isc_vtov ((const char*) fq_name, (char*) isc_226.isc_227, 125);
                isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_func_args], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_226, (short) 0);
		while (1)
		   {
                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_func_args], (short) 1, (short) 14, &isc_228, (short) 0);
		   if (!isc_228.isc_229) break;
			if (/*FA.RDB$ARGUMENT_POSITION*/
			    isc_228.isc_235 == 0) {
				ERRQ_msg_partial(427); // Msg427 Return argument is
			}
			else
			{
				ERRQ_msg_partial(428, SafeArg() << /*FA.RDB$ARGUMENT_POSITION*/
								   isc_228.isc_235);
				// Msg428 Argument %d is
			}

			const USHORT array = (/*FA.RDB$MECHANISM*/
					      isc_228.isc_234 == 2); // funct below wants USHORT
			show_datatype(database, MET_get_datatype(/*FA.RDB$FIELD_TYPE*/
								 isc_228.isc_233),
						  /*FA.RDB$FIELD_LENGTH*/
						  isc_228.isc_232, /*FA.RDB$FIELD_SCALE*/
  isc_228.isc_231,
						  /*FA.RDB$FIELD_SUB_TYPE*/
						  isc_228.isc_230, 0, array);
			printf("\n");
		/*END_FOR;*/
		   }
		}

		show_text_blob(database, "\t", 421, &/*F.RDB$DESCRIPTION*/
						     isc_240.isc_241, 0, NULL, false);

	/*END_FOR;*/
	   }
	}
	return count;
}


static void show_funcs( qli_dbb* database)
{
/**************************************
 *
 *	s h o w _ f u n c s
 *
 **************************************
 *
 * Functional description
 *	Show function names in all ready databases,
 *	or a specific database.
 *
 **************************************/

	if (!(database->dbb_capabilities & DBB_cap_functions))
	{
		ERRQ_msg_put(461, database->dbb_symbol->sym_string);
		// 461 - functions aren't supported in this database
	}

	if (!(show_funcs_detail(database)))
	{
		ERRQ_msg_put(462, database->dbb_symbol->sym_string);
		// 462 - no functions are defined in this database
	}
}


static int show_funcs_detail( qli_dbb* database)
{
   struct isc_222_struct {
          short isc_223;	/* isc_utility */
          char  isc_224 [125];	/* RDB$FUNCTION_NAME */
   } isc_222;
/**************************************
 *
 *	s h o w _ f u n c s _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show function names in a database.
 *
 **************************************/
	buf_type buffer;
	SSHORT width = get_window_size(sizeof(buffer) - 1);
	buffer[0] = 0;

	MET_meta_transaction(database, false);

	int count = 0;
	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_functions])
		F IN RDB$FUNCTIONS
		SORTED BY F.RDB$FUNCTION_NAME*/
	{
        if (!database->dbb_requests[REQ_show_functions])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_functions], (short) sizeof(isc_221), (char*) isc_221);
        isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_functions], (FB_API_HANDLE*) &gds_trans, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_functions], (short) 0, (short) 127, &isc_222, (short) 0);
	   if (!isc_222.isc_223) break;
		if (!count++)
		{
			// Msg416 Functions in database %s (%s):
			ERRQ_msg_put(416, SafeArg() << database->dbb_filename <<
						   database->dbb_symbol->sym_string);
		}
		show_names(/*F.RDB$FUNCTION_NAME*/
			   isc_222.isc_224, width, buffer);
	/*END_FOR;*/
	   }
	}

	if (buffer[0])
		printf("%s\n", buffer);

	return count;
}


static int show_insecure_fields(qli_dbb* database,
								const TEXT* relation_name,
								const TEXT* field_name)
{
   struct isc_194_struct {
          ISC_QUAD isc_195;	/* RDB$QUERY_HEADER */
          ISC_QUAD isc_196;	/* RDB$QUERY_HEADER */
          char  isc_197 [128];	/* RDB$EDIT_STRING */
          char  isc_198 [128];	/* RDB$EDIT_STRING */
          ISC_QUAD isc_199;	/* RDB$VALIDATION_BLR */
          ISC_QUAD isc_200;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD isc_201;	/* RDB$COMPUTED_BLR */
          ISC_QUAD isc_202;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD isc_203;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_204;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_205;	/* RDB$VIEW_BLR */
          short isc_206;	/* isc_utility */
          short isc_207;	/* RDB$SEGMENT_LENGTH */
          short isc_208;	/* RDB$FIELD_SUB_TYPE */
          short isc_209;	/* RDB$FIELD_SCALE */
          short isc_210;	/* RDB$FIELD_LENGTH */
          short isc_211;	/* RDB$FIELD_TYPE */
          short isc_212;	/* RDB$VIEW_CONTEXT */
          short isc_213;	/* gds__null_flag */
          short isc_214;	/* gds__null_flag */
          char  isc_215 [125];	/* RDB$RELATION_NAME */
          char  isc_216 [125];	/* RDB$FIELD_NAME */
          char  isc_217 [125];	/* RDB$FIELD_NAME */
          char  isc_218 [125];	/* RDB$BASE_FIELD */
          char  isc_219 [125];	/* RDB$QUERY_NAME */
          char  isc_220 [125];	/* RDB$QUERY_NAME */
   } isc_194;
   struct isc_190_struct {
          char  isc_191 [125];	/* RDB$FIELD_NAME */
          char  isc_192 [125];	/* RDB$QUERY_NAME */
          char  isc_193 [125];	/* RDB$QUERY_NAME */
   } isc_190;
/**************************************
 *
 *	s h o w _ i n s e c u r e _ f i e l d s
 *
 **************************************
 *
 * Functional description
 *	Show everything we know about local
 *	fields with the specified name in a particular
 *	database, that doesn't have security classes
 *	defined.
 *
 **************************************/
	int count = 0;

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_field])
		RFR IN RDB$RELATION_FIELDS CROSS
			F IN RDB$FIELDS CROSS
			R IN RDB$RELATIONS WITH
			RFR.RDB$FIELD_SOURCE = F.RDB$FIELD_NAME AND
			R.RDB$RELATION_NAME = RFR.RDB$RELATION_NAME AND
			(RFR.RDB$FIELD_NAME = field_name OR
			 RFR.RDB$QUERY_NAME = field_name OR
			 (RFR.RDB$QUERY_NAME MISSING AND F.RDB$QUERY_NAME = field_name))*/
	{
        if (!database->dbb_requests[REQ_show_field])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_field], (short) sizeof(isc_189), (char*) isc_189);
	isc_vtov ((const char*) field_name, (char*) isc_190.isc_191, 125);
	isc_vtov ((const char*) field_name, (char*) isc_190.isc_192, 125);
	isc_vtov ((const char*) field_name, (char*) isc_190.isc_193, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_field], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 375, &isc_190, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_field], (short) 1, (short) 1096, &isc_194, (short) 0);
	   if (!isc_194.isc_206) break;

		fb_utils::exact_name(/*RFR.RDB$RELATION_NAME*/
				     isc_194.isc_215);
		if (relation_name && (strcmp(/*RFR.RDB$RELATION_NAME*/
					     isc_194.isc_215, relation_name)))
			continue;
		if (count++)
			printf("\n");
		fb_utils::exact_name(/*RFR.RDB$FIELD_NAME*/
				     isc_194.isc_216);
		fb_utils::exact_name(/*F.RDB$FIELD_NAME*/
				     isc_194.isc_217);

		if (/*R.RDB$VIEW_BLR.NULL*/
		    isc_194.isc_214)
		{
			ERRQ_msg_put(496, SafeArg() << /*RFR.RDB$FIELD_NAME*/
						       isc_194.isc_216 << /*RFR.RDB$RELATION_NAME*/
    isc_194.isc_215 <<
						 database->dbb_symbol->sym_string);
			// Msg495 Field %s in relation %s of database %s
		}
		else
		{
			ERRQ_msg_put(495, SafeArg() << /*RFR.RDB$FIELD_NAME*/
						       isc_194.isc_216 << /*RFR.RDB$RELATION_NAME*/
    isc_194.isc_215 <<
						 database->dbb_symbol->sym_string);
			// Msg495 Field %s in view %s of database %s
		}
		ERRQ_msg_put(338, /*F.RDB$FIELD_NAME*/
				  isc_194.isc_217);
		// Msg338 Global field %s

		if (!/*RFR.RDB$BASE_FIELD.NULL*/
		     isc_194.isc_213)
		{
			fb_utils::exact_name(/*RFR.RDB$BASE_FIELD*/
					     isc_194.isc_218);
			view_info(database, /*RFR.RDB$RELATION_NAME*/
					    isc_194.isc_215, /*RFR.RDB$BASE_FIELD*/
  isc_194.isc_218, /*RFR.RDB$VIEW_CONTEXT*/
  isc_194.isc_212, 0);
		}

		show_text_blob(database, "\t", 339, &/*RFR.RDB$DESCRIPTION*/
						     isc_194.isc_204, 339, &/*F.RDB$DESCRIPTION*/
	isc_194.isc_203, false);
		ERRQ_msg_partial(340);	// Msg340 Datatype information:
		printf("\t");
		show_datatype(database, MET_get_datatype(/*F.RDB$FIELD_TYPE*/
							 isc_194.isc_211),
					  /*F.RDB$FIELD_LENGTH*/
					  isc_194.isc_210, /*F.RDB$FIELD_SCALE*/
  isc_194.isc_209,
					  /*F.RDB$FIELD_SUB_TYPE*/
					  isc_194.isc_208, /*F.RDB$SEGMENT_LENGTH*/
  isc_194.isc_207,
					  MET_dimensions(database, /*F.RDB$FIELD_NAME*/
								   isc_194.isc_217));
		printf("\n");
		show_blr(database, 341, /*F.RDB$COMPUTED_SOURCE*/
					isc_194.isc_202, 341, /*F.RDB$COMPUTED_BLR*/
       isc_194.isc_201);
		show_blr(database, 342, /*F.RDB$VALIDATION_SOURCE*/
					isc_194.isc_200, 342, /*F.RDB$VALIDATION_BLR*/
       isc_194.isc_199);
		show_string(343, /*RFR.RDB$QUERY_NAME*/
				 isc_194.isc_219, 343, /*F.RDB$QUERY_NAME*/
       isc_194.isc_220);
		show_string(346, /*RFR.RDB$EDIT_STRING*/
				 isc_194.isc_198, 346, /*F.RDB$EDIT_STRING*/
       isc_194.isc_197);
		show_text_blob(database, "\t", 345, &/*RFR.RDB$QUERY_HEADER*/
						     isc_194.isc_196, 345, &/*F.RDB$QUERY_HEADER*/
	isc_194.isc_195, false);
	/*END_FOR;*/
	   }
	}

	return count;
}


static void show_gbl_field( qli_syntax* field_node)
{
/**************************************
 *
 *	s h o w _ g b l _ f i e l d
 *
 **************************************
 *
 * Functional description
 *	Show what we know about a global
 *	field.  It may be qualified with a
 *	database handle, in which case, show only
 *	the one global field in that database,
 *	otherwise show them all.
 *
 **************************************/
	qli_name* field_name = NULL;
	qli_dbb* database = NULL;

	for (qli_syntax** ptr = field_node->syn_arg + field_node->syn_count - 1;
		ptr >= field_node->syn_arg; ptr--)
	{
		if (!field_name) {
			field_name = (qli_name*) * ptr;
		}
		else
		{
			qli_name* name = (qli_name*) *ptr;
			for (qli_symbol* symbol = name->nam_symbol; symbol; symbol = symbol->sym_homonym)
			{
				if (symbol->sym_type == SYM_database)
				{
					database = (qli_dbb*) symbol->sym_object;
					break;
				}
			}
		}
	}

	int count = 0;
	if (database)
	{
		count += show_gbl_field_detail(database, field_name->nam_string);
		if (!count)
		{
			ERRQ_msg_put(122,	// Msg122 Global field %s does not exist in database %s
						 SafeArg() << field_name->nam_string <<
						 database->dbb_symbol->sym_string);
		}
	}
	else
	{
		for (database = QLI_databases; database; database = database->dbb_next)
			count += show_gbl_field_detail(database, field_name->nam_string);
		if (!count)
		{
			ERRQ_msg_put(123, field_name->nam_string);
			// Msg123 Global field %s does not exist in any open database
		}
	}
}


static int show_gbl_field_detail( qli_dbb* database, const TEXT* field_name)
{
   struct isc_173_struct {
          ISC_QUAD isc_174;	/* RDB$QUERY_HEADER */
          char  isc_175 [128];	/* RDB$EDIT_STRING */
          ISC_QUAD isc_176;	/* RDB$VALIDATION_BLR */
          ISC_QUAD isc_177;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD isc_178;	/* RDB$COMPUTED_BLR */
          ISC_QUAD isc_179;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD isc_180;	/* RDB$DESCRIPTION */
          short isc_181;	/* isc_utility */
          short isc_182;	/* RDB$SEGMENT_LENGTH */
          short isc_183;	/* RDB$FIELD_SUB_TYPE */
          short isc_184;	/* RDB$FIELD_SCALE */
          short isc_185;	/* RDB$FIELD_LENGTH */
          short isc_186;	/* RDB$FIELD_TYPE */
          char  isc_187 [125];	/* RDB$FIELD_NAME */
          char  isc_188 [125];	/* RDB$QUERY_NAME */
   } isc_173;
   struct isc_171_struct {
          char  isc_172 [125];	/* RDB$FIELD_NAME */
   } isc_171;
/**************************************
 *
 *	s h o w _ g b l _ f i e l d _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show everything we know about a global
 *	field with the specified name in a particular
 *	database.
 *
 **************************************/
	int count = 0;

	MET_meta_transaction(database, false);

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_global_field])
		F IN RDB$FIELDS WITH F.RDB$FIELD_NAME = field_name*/
	{
        if (!database->dbb_requests[REQ_show_global_field])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_global_field], (short) sizeof(isc_170), (char*) isc_170);
	isc_vtov ((const char*) field_name, (char*) isc_171.isc_172, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_global_field], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_171, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_global_field], (short) 1, (short) 438, &isc_173, (short) 0);
	   if (!isc_173.isc_181) break;

		if (count++)
			printf("\n");
		fb_utils::exact_name(/*F.RDB$FIELD_NAME*/
				     isc_173.isc_187);

		ERRQ_msg_put(276, SafeArg() << /*F.RDB$FIELD_NAME*/
					       isc_173.isc_187 << database->dbb_symbol->sym_string);
		// Msg276 Global field %s in database %s

		show_text_blob(database, "\t", 277, &/*F.RDB$DESCRIPTION*/
						     isc_173.isc_180, 0, NULL, false);
		ERRQ_msg_put(278);	// Msg278 Datatype information:
		printf("\t");
		show_datatype(database, MET_get_datatype(/*F.RDB$FIELD_TYPE*/
							 isc_173.isc_186),
					  /*F.RDB$FIELD_LENGTH*/
					  isc_173.isc_185, /*F.RDB$FIELD_SCALE*/
  isc_173.isc_184,
					  /*F.RDB$FIELD_SUB_TYPE*/
					  isc_173.isc_183, /*F.RDB$SEGMENT_LENGTH*/
  isc_173.isc_182,
					  MET_dimensions(database, /*F.RDB$FIELD_NAME*/
								   isc_173.isc_187));
		printf("\n");
		show_blr(database, 279, /*F.RDB$COMPUTED_SOURCE*/
					isc_173.isc_179, 341, /*F.RDB$COMPUTED_BLR*/
       isc_173.isc_178);
		show_blr(database, 280, /*F.RDB$VALIDATION_SOURCE*/
					isc_173.isc_177, 342, /*F.RDB$VALIDATION_BLR*/
       isc_173.isc_176);
		show_string(281, /*F.RDB$QUERY_NAME*/
				 isc_173.isc_188, 0, NULL);
		show_string(282, /*F.RDB$EDIT_STRING*/
				 isc_173.isc_175, 0, NULL);
		show_text_blob(database, "\t", 283, &/*F.RDB$QUERY_HEADER*/
						     isc_173.isc_174, 0, NULL, false);
	/*END_FOR;*/
	   }
	}

	if (count && !(show_field_instances(database, field_name)))
	{
		ERRQ_msg_put(284, SafeArg() << field_name << database->dbb_symbol->sym_string);
		// Msg284 %s is not used in any relations in database %s
	}

	return count;
}


static void show_gbl_fields( qli_dbb* database)
{
/**************************************
 *
 *	s h o w _ g b l _ f i e l d s
 *
 **************************************
 *
 * Functional description
 *	Show what we know about a global
 *	field.  It may be qualified with a
 *	database handle, in which case, show only
 *	the global fields in that database,
 *	otherwise show them all.
 *
 **************************************/
	int count = 0;
	if (database)
	{
		count += show_gbl_fields_detail(database);
		if (!count)
		{
			ERRQ_msg_put(124, database->dbb_symbol->sym_string);
			// Msg124 There are no fields defined for database %s
		}
	}
	else
	{
		for (database = QLI_databases; database; database = database->dbb_next)
		{
			count += show_gbl_fields_detail(database);
		}
		if (!count) {
			ERRQ_msg_put(125); // Msg125 There are no fields defined in any open database
		}
	}
}


static int show_gbl_fields_detail( qli_dbb* database)
{
   struct isc_159_struct {
          ISC_QUAD isc_160;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_161;	/* RDB$COMPUTED_BLR */
          short isc_162;	/* isc_utility */
          short isc_163;	/* RDB$SEGMENT_LENGTH */
          short isc_164;	/* RDB$FIELD_SUB_TYPE */
          short isc_165;	/* RDB$FIELD_SCALE */
          short isc_166;	/* RDB$FIELD_LENGTH */
          short isc_167;	/* RDB$FIELD_TYPE */
          short isc_168;	/* gds__null_flag */
          char  isc_169 [125];	/* RDB$FIELD_NAME */
   } isc_159;
/**************************************
 *
 *	s h o w _ g b l _ f i e l d s _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show everything we know about
 *	global fields in a particular
 *	database.
 *
 **************************************/
	int count = 0;

	MET_meta_transaction(database, false);

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_global_fields])
		F IN RDB$FIELDS WITH F.RDB$SYSTEM_FLAG MISSING OR
			F.RDB$SYSTEM_FLAG = 0 SORTED BY F.RDB$FIELD_NAME*/
	{
        if (!database->dbb_requests[REQ_show_global_fields])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_global_fields], (short) sizeof(isc_158), (char*) isc_158);
        isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_global_fields], (FB_API_HANDLE*) &gds_trans, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_global_fields], (short) 0, (short) 155, &isc_159, (short) 0);
	   if (!isc_159.isc_162) break;

		if (!count++)
		{
			ERRQ_msg_put(286, SafeArg() << database->dbb_symbol->sym_string);
			// Msg286 Global fields for database %s:
		}
		if (!/*F.RDB$COMPUTED_BLR.NULL*/
		     isc_159.isc_168)
			continue;
		printf("    %s", /*F.RDB$FIELD_NAME*/
				 isc_159.isc_169);
		show_datatype(database, MET_get_datatype(/*F.RDB$FIELD_TYPE*/
							 isc_159.isc_167),
					  /*F.RDB$FIELD_LENGTH*/
					  isc_159.isc_166, /*F.RDB$FIELD_SCALE*/
  isc_159.isc_165,
					  /*F.RDB$FIELD_SUB_TYPE*/
					  isc_159.isc_164, /*F.RDB$SEGMENT_LENGTH*/
  isc_159.isc_163,
					  MET_dimensions(database, /*F.RDB$FIELD_NAME*/
								   isc_159.isc_169));
		show_text_blob(database, "\t", 262, &/*F.RDB$DESCRIPTION*/
						     isc_159.isc_160, 0, NULL, false);
		printf("\n");
	/*END_FOR;*/
	   }
	}

	return count;
}


static int show_indices_detail( qli_rel* relation)
{
   struct isc_124_struct {
          short isc_125;	/* isc_utility */
          char  isc_126 [125];	/* RDB$FIELD_NAME */
   } isc_124;
   struct isc_122_struct {
          char  isc_123 [125];	/* RDB$INDEX_NAME */
   } isc_122;
   struct isc_130_struct {
          short isc_131;	/* isc_utility */
          short isc_132;	/* RDB$UNIQUE_FLAG */
          char  isc_133 [125];	/* RDB$INDEX_NAME */
   } isc_130;
   struct isc_128_struct {
          char  isc_129 [125];	/* RDB$RELATION_NAME */
   } isc_128;
   struct isc_137_struct {
          short isc_138;	/* isc_utility */
          char  isc_139 [125];	/* RDB$FIELD_NAME */
   } isc_137;
   struct isc_135_struct {
          char  isc_136 [125];	/* RDB$INDEX_NAME */
   } isc_135;
   struct isc_143_struct {
          short isc_144;	/* isc_utility */
          short isc_145;	/* RDB$INDEX_TYPE */
   } isc_143;
   struct isc_141_struct {
          char  isc_142 [125];	/* RDB$INDEX_NAME */
   } isc_141;
   struct isc_149_struct {
          ISC_QUAD isc_150;	/* RDB$EXPRESSION_BLR */
          ISC_QUAD isc_151;	/* RDB$EXPRESSION_SOURCE */
          short isc_152;	/* isc_utility */
          short isc_153;	/* gds__null_flag */
          short isc_154;	/* gds__null_flag */
          short isc_155;	/* RDB$INDEX_INACTIVE */
          short isc_156;	/* RDB$UNIQUE_FLAG */
          char  isc_157 [125];	/* RDB$INDEX_NAME */
   } isc_149;
   struct isc_147_struct {
          char  isc_148 [125];	/* RDB$RELATION_NAME */
   } isc_147;
/**************************************
 *
 *	s h o w _ i n d i c e s _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show indices for a relation.  If none, return 0.
 *
 **************************************/
	USHORT count = 0;

	qli_dbb* database = relation->rel_database;
	MET_meta_transaction(database, false);

	if (database->dbb_capabilities & DBB_cap_idx_inactive)
	{
		/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_indices])
			X IN RDB$INDICES CROSS Z IN RDB$RELATIONS
				WITH X.RDB$RELATION_NAME EQ relation->rel_symbol->sym_string
				AND Z.RDB$RELATION_NAME EQ X.RDB$RELATION_NAME
				AND Z.RDB$VIEW_BLR MISSING SORTED BY X.RDB$INDEX_NAME*/
		{
                if (!database->dbb_requests[REQ_show_indices])
                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_indices], (short) sizeof(isc_146), (char*) isc_146);
		isc_vtov ((const char*) relation->rel_symbol->sym_string, (char*) isc_147.isc_148, 125);
                isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_indices], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_147, (short) 0);
		while (1)
		   {
                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_indices], (short) 1, (short) 151, &isc_149, (short) 0);
		   if (!isc_149.isc_152) break;
			++count;
			USHORT type = 0; // this wasn't reset for each index!
			if (database->dbb_capabilities & DBB_cap_index_type)
			{
				/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_index_type])
					Y IN RDB$INDICES WITH Y.RDB$INDEX_NAME = X.RDB$INDEX_NAME*/
				{
                                if (!database->dbb_requests[REQ_show_index_type])
                                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_index_type], (short) sizeof(isc_140), (char*) isc_140);
				isc_vtov ((const char*) isc_149.isc_157, (char*) isc_141.isc_142, 125);
                                isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_index_type], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_141, (short) 0);
				while (1)
				   {
                                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_index_type], (short) 1, (short) 4, &isc_143, (short) 0);
				   if (!isc_143.isc_144) break;

					type = /*Y.RDB$INDEX_TYPE*/
					       isc_143.isc_145;
				/*END_FOR;*/
				   }
				}
			}

			fb_utils::exact_name(/*X.RDB$INDEX_NAME*/
					     isc_149.isc_157);
			ERRQ_msg_put(450, SafeArg() << /*X.RDB$INDEX_NAME*/
						       isc_149.isc_157 <<
						 ((/*X.RDB$UNIQUE_FLAG*/
						   isc_149.isc_156) ? " (unique)" : "") <<
						 ((type == 1) ? " (descending)" : "") <<
						 ((/*X.RDB$INDEX_INACTIVE*/
						   isc_149.isc_155) ? " (inactive)" : ""));
			// Msg450 Index %s%s%s%s

			/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_index])
				Y IN RDB$INDEX_SEGMENTS WITH
					Y.RDB$INDEX_NAME EQ X.RDB$INDEX_NAME
					SORTED BY Y.RDB$FIELD_POSITION*/
			{
                        if (!database->dbb_requests[REQ_show_index])
                           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_index], (short) sizeof(isc_134), (char*) isc_134);
			isc_vtov ((const char*) isc_149.isc_157, (char*) isc_135.isc_136, 125);
                        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_index], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_135, (short) 0);
			while (1)
			   {
                           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_index], (short) 1, (short) 127, &isc_137, (short) 0);
			   if (!isc_137.isc_138) break;

				fb_utils::exact_name(/*Y.RDB$FIELD_NAME*/
						     isc_137.isc_139);
				printf("            %s\n", /*Y.RDB$FIELD_NAME*/
							   isc_137.isc_139);
			/*END_FOR;*/
			   }
			}


			if (!/*X.RDB$EXPRESSION_SOURCE.NULL*/
			     isc_149.isc_154)
				show_text_blob(database, "\t    ", 0, &/*X.RDB$EXPRESSION_SOURCE*/
								       isc_149.isc_151, 0, NULL, true);
			else if (!/*X.RDB$EXPRESSION_BLR.NULL*/
				  isc_149.isc_153)
			{
				ERRQ_msg_put (485);
				display_blr(database, /*X.RDB$EXPRESSION_BLR*/
						      isc_149.isc_150);
			}

		/*END_FOR;*/
		   }
		}
	}
	else
	{
		/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_indices])
			X IN RDB$INDICES CROSS Z IN RDB$RELATIONS
				WITH X.RDB$RELATION_NAME EQ relation->rel_symbol->sym_string
				AND Z.RDB$RELATION_NAME EQ X.RDB$RELATION_NAME
				AND Z.RDB$VIEW_BLR MISSING SORTED BY X.RDB$INDEX_NAME*/
		{
                if (!database->dbb_requests[REQ_show_indices])
                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_indices], (short) sizeof(isc_127), (char*) isc_127);
		isc_vtov ((const char*) relation->rel_symbol->sym_string, (char*) isc_128.isc_129, 125);
                isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_indices], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_128, (short) 0);
		while (1)
		   {
                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_indices], (short) 1, (short) 129, &isc_130, (short) 0);
		   if (!isc_130.isc_131) break;

			++count;
			fb_utils::exact_name(/*X.RDB$INDEX_NAME*/
					     isc_130.isc_133);
			ERRQ_msg_put(290, SafeArg() << /*X.RDB$INDEX_NAME*/
						       isc_130.isc_133 <<
						 ((/*X.RDB$UNIQUE_FLAG*/
						   isc_130.isc_132) ? " (unique)" : ""));	// Msg290 Index %s%s
			/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_index])
				Y IN RDB$INDEX_SEGMENTS WITH
					Y.RDB$INDEX_NAME EQ X.RDB$INDEX_NAME
					SORTED BY Y.RDB$FIELD_POSITION*/
			{
                        if (!database->dbb_requests[REQ_show_index])
                           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_index], (short) sizeof(isc_121), (char*) isc_121);
			isc_vtov ((const char*) isc_130.isc_133, (char*) isc_122.isc_123, 125);
                        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_index], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_122, (short) 0);
			while (1)
			   {
                           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_index], (short) 1, (short) 127, &isc_124, (short) 0);
			   if (!isc_124.isc_125) break;
				fb_utils::exact_name(/*Y.RDB$FIELD_NAME*/
						     isc_124.isc_126);
				printf("            %s\n", /*Y.RDB$FIELD_NAME*/
							   isc_124.isc_126);
			/*END_FOR;*/
			   }
			}
		/*END_FOR;*/
		   }
		}
	}

	return count;
}


static void show_matching()
{
/**************************************
 *
 *	s h o w _ m a t c h i n g
 *
 **************************************
 *
 * Functional description
 *	Just print the QLI matching language string.
 *
 **************************************/
	if (QLI_abort)
		return;
	if (QLI_matching_language)
	{
		printf("\n\t%.*s\n",
			int(QLI_matching_language->con_desc.dsc_length), QLI_matching_language->con_data);
	}
}


static void show_names( const TEXT* name, USHORT width, TEXT* buffer)
{
/**************************************
 *
 *	s h o w _ n a m e s
 *
 **************************************
 *
 * Functional description
 *
 **************************************/
	/*BASED ON QLI$PROCEDURES.QLI$PROCEDURE_NAME padded_name;*/
	char
	   padded_name[32];

	FB_UNUSED_VAR(padded_name); // Silence compiler warning

	TEXT* s = buffer + strlen(buffer);
	SSHORT len = sizeof(padded_name) - 1;
	const SSHORT l1 = s - buffer;
	if ((s != buffer) && ((l1 + len + 4) > width))
	{
		printf("%s\n", buffer);
		buffer[0] = 0;
		s = buffer;
	}
	*s++ = ' ';
	*s++ = ' ';
	*s++ = ' ';
	*s++ = ' ';
	strcpy(s, name);
	while (*s)
	{
		s++;
		len--;
	}
	while (len--) {
		*s++ = ' ';
	}
	*s = 0;
}


static void show_proc( qli_proc* proc)
{
/**************************************
 *
 *	s h o w _ p r o c
 *
 **************************************
 *
 * Functional description
 *	Show definition of procedure.  If a particular database
 *	was specified, look there, otherwise, print all procedures
 *	with that name.
 *
 **************************************/
	const qli_name* name = proc->qpr_name;

	qli_dbb* database = proc->qpr_database;
	if (database)
	{
		FB_API_HANDLE blob = PRO_fetch_procedure(database, (TEXT*) name->nam_string);
		if (blob)
			display_procedure(database, (const UCHAR*) name->nam_string, blob);
		else
		{
			// Msg126 Procedure %s not found in database %s
			ERRQ_msg_put(126, SafeArg() << name->nam_string << database->dbb_symbol->sym_string);
		}
		return;
	}

	int count = 0;
	for (database = QLI_databases; database; database = database->dbb_next)
	{
		FB_API_HANDLE blob = PRO_fetch_procedure(database, (TEXT*) name->nam_string);
		if (blob)
		{
			display_procedure(database, (const UCHAR*) name->nam_string, blob);
			count++;
		}
	}

	if (!count)
	{
		ERRQ_msg_put(127, name->nam_string); // Msg127 Procedure %s not found
		return;
	}
}


static void show_procs( qli_dbb* database)
{
   struct isc_118_struct {
          char  isc_119 [32];	/* QLI$PROCEDURE_NAME */
          short isc_120;	/* isc_utility */
   } isc_118;
/**************************************
 *
 *	s h o w _ p r o c s
 *
 **************************************
 *
 * Functional description
 *	Show procedures in a database
 *
 **************************************/
	buf_type buffer;

	const SSHORT width = get_window_size(sizeof(buffer) - 1);

	PRO_setup(database);
	ERRQ_msg_put(128, SafeArg() << database->dbb_filename <<	// Msg128 Procedures in database %s (%s):
				 database->dbb_symbol->sym_string);
	buffer[0] = 0;
	/*FOR(REQUEST_HANDLE database->dbb_scan_blobs) X IN DB.QLI$PROCEDURES
		SORTED BY X.QLI$PROCEDURE_NAME*/
	{
        if (!database->dbb_scan_blobs)
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_scan_blobs, (short) sizeof(isc_117), (char*) isc_117);
        isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_scan_blobs, (FB_API_HANDLE*) &gds_trans, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_scan_blobs, (short) 0, (short) 34, &isc_118, (short) 0);
	   if (!isc_118.isc_120) break;
		show_names(/*X.QLI$PROCEDURE_NAME*/
			   isc_118.isc_119, width, buffer);
	/*END_FOR;*/
	   }
	}
	if (buffer[0])
		printf("%s\n", buffer);
}


static void show_rel( qli_rel* relation)
{
/**************************************
 *
 *	s h o w _ r e l
 *
 **************************************
 *
 * Functional description
 *	Just print a relation name.  Almost mindless.
 *
 **************************************/

	if (QLI_abort)
		return;

	printf("    %s\n", relation->rel_symbol->sym_string);
}


static void show_rel_detail( qli_rel* relation)
{
   struct isc_90_struct {
          ISC_INT64 isc_91;	/* RDB$TRIGGER_TYPE */
          ISC_QUAD isc_92;	/* RDB$TRIGGER_BLR */
          short isc_93;	/* isc_utility */
          short isc_94;	/* RDB$TRIGGER_SEQUENCE */
          short isc_95;	/* RDB$TRIGGER_INACTIVE */
          short isc_96;	/* gds__null_flag */
          char  isc_97 [125];	/* RDB$TRIGGER_NAME */
   } isc_90;
   struct isc_88_struct {
          char  isc_89 [125];	/* RDB$RELATION_NAME */
   } isc_88;
   struct isc_101_struct {
          char  isc_102 [256];	/* RDB$EXTERNAL_FILE */
          short isc_103;	/* isc_utility */
   } isc_101;
   struct isc_99_struct {
          char  isc_100 [125];	/* RDB$RELATION_NAME */
   } isc_99;
   struct isc_107_struct {
          short isc_108;	/* isc_utility */
          char  isc_109 [125];	/* RDB$SECURITY_CLASS */
   } isc_107;
   struct isc_105_struct {
          char  isc_106 [125];	/* RDB$RELATION_NAME */
   } isc_105;
   struct isc_113_struct {
          ISC_QUAD isc_114;	/* RDB$DESCRIPTION */
          short isc_115;	/* isc_utility */
          char  isc_116 [125];	/* RDB$RELATION_NAME */
   } isc_113;
   struct isc_111_struct {
          char  isc_112 [125];	/* RDB$RELATION_NAME */
   } isc_111;
/**************************************
 *
 *	s h o w _ r e l _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Ask META to print description,
 *	security class, etc.
 *
 **************************************/
	const TEXT* relation_name = relation->rel_symbol->sym_string;
	qli_dbb* database = relation->rel_database;
	MET_meta_transaction(database, false);

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_rel_detail])
		R IN RDB$RELATIONS WITH R.RDB$RELATION_NAME = relation_name*/
	{
        if (!database->dbb_requests[REQ_show_rel_detail])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_rel_detail], (short) sizeof(isc_110), (char*) isc_110);
	isc_vtov ((const char*) relation_name, (char*) isc_111.isc_112, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_rel_detail], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_111, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_rel_detail], (short) 1, (short) 135, &isc_113, (short) 0);
	   if (!isc_113.isc_115) break;
		show_text_blob(database, "\t", 291, &/*R.RDB$DESCRIPTION*/
						     isc_113.isc_114, 0, NULL, false);

		if (database->dbb_capabilities & DBB_cap_security)
		{
			/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_rel_secur])
				S IN RDB$RELATIONS WITH S.RDB$RELATION_NAME = R.RDB$RELATION_NAME
					AND S.RDB$SECURITY_CLASS NOT MISSING*/
			{
                        if (!database->dbb_requests[REQ_show_rel_secur])
                           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_rel_secur], (short) sizeof(isc_104), (char*) isc_104);
			isc_vtov ((const char*) isc_113.isc_116, (char*) isc_105.isc_106, 125);
                        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_rel_secur], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_105, (short) 0);
			while (1)
			   {
                           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_rel_secur], (short) 1, (short) 127, &isc_107, (short) 0);
			   if (!isc_107.isc_108) break;
				show_string(292, /*S.RDB$SECURITY_CLASS*/
						 isc_107.isc_109, 0, NULL);
			/*END_FOR;*/
			   }
			}
		}

		if (database->dbb_capabilities & DBB_cap_extern_file)
		{
			/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_rel_extern])
				E IN RDB$RELATIONS WITH E.RDB$RELATION_NAME = R.RDB$RELATION_NAME
					AND E.RDB$EXTERNAL_FILE NOT MISSING*/
			{
                        if (!database->dbb_requests[REQ_show_rel_extern])
                           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_rel_extern], (short) sizeof(isc_98), (char*) isc_98);
			isc_vtov ((const char*) isc_113.isc_116, (char*) isc_99.isc_100, 125);
                        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_rel_extern], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_99, (short) 0);
			while (1)
			   {
                           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_rel_extern], (short) 1, (short) 258, &isc_101, (short) 0);
			   if (!isc_101.isc_103) break;
				ERRQ_msg_put(293, /*E.RDB$EXTERNAL_FILE*/
						  isc_101.isc_102);	// Msg293 Stored in external file %s
			/*END_FOR;*/
			   }
			}
		}

		// OBSOLETE - Handling of DBB_cap_triggers (old V2 style triggers)
		// OBSOLETE - Msg294 An erase trigger is defined for %s
		// OBSOLETE - Msg295 A modify trigger is defined for %s
		// OBSOLETE - Msg296 A store trigger is defined for %s

		if (database->dbb_capabilities & DBB_cap_new_triggers)
		{
			USHORT msg = 380;
			/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_new_trig_exists])
				X IN RDB$TRIGGERS
				WITH X.RDB$RELATION_NAME EQ relation->rel_symbol->sym_string*/
			{
                        if (!database->dbb_requests[REQ_new_trig_exists])
                           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_new_trig_exists], (short) sizeof(isc_87), (char*) isc_87);
			isc_vtov ((const char*) relation->rel_symbol->sym_string, (char*) isc_88.isc_89, 125);
                        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_new_trig_exists], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_88, (short) 0);
			while (1)
			   {
                           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_new_trig_exists], (short) 1, (short) 149, &isc_90, (short) 0);
			   if (!isc_90.isc_93) break;
				if (!/*X.RDB$TRIGGER_BLR.NULL*/
				     isc_90.isc_96)
				{
					if (msg)
					{
						ERRQ_msg_put(msg); // Msg380 Trigger defined for this relation
						msg = 0;
					}
					printf("\t");
					show_trigger_status(/*X.RDB$TRIGGER_NAME*/
							    isc_90.isc_97, /*X.RDB$TRIGGER_TYPE*/
  isc_90.isc_91,
										/*X.RDB$TRIGGER_INACTIVE*/
										isc_90.isc_95, /*X.RDB$TRIGGER_SEQUENCE*/
  isc_90.isc_94);
				}
			/*END_FOR;*/
			   }
			}
		}
	/*END_FOR;*/
	   }
	}
}


static void show_rels( qli_dbb* dbb, enum show_t sw, SSHORT width)
{
/**************************************
 *
 *	s h o w _ r e l s
 *
 **************************************
 *
 * Functional description
 *	Display information about a relations
 *      or system_relations for a specific database.
 *
 **************************************/
	buf_type buffer;

	switch (sw)
	{
	case show_relations:
		show_dbb(dbb);
		buffer[0] = 0;
		for (const qli_rel* relation = dbb->dbb_relations; relation;
			 relation = relation->rel_next)
		{
			if (!(relation->rel_flags & REL_system))
				show_names(relation->rel_symbol->sym_string, width, buffer);
		}
		if (buffer[0])
			printf("%s\n", buffer);
		printf("\n");
		break;
	case show_system_relations:
		show_dbb(dbb);
		buffer[0] = 0;
		for (const qli_rel* relation = dbb->dbb_relations; relation;
			 relation = relation->rel_next)
		{
			if (relation->rel_flags & REL_system)
				show_names(relation->rel_symbol->sym_string, width, buffer);
		}
		if (buffer[0])
			printf("%s\n", buffer);
		printf("\n");
	}
}


static USHORT show_security_class_detail( qli_dbb* database, const TEXT* name)
{
   struct isc_83_struct {
          ISC_QUAD isc_84;	/* RDB$ACL */
          short isc_85;	/* isc_utility */
          char  isc_86 [125];	/* RDB$SECURITY_CLASS */
   } isc_83;
   struct isc_81_struct {
          char  isc_82 [125];	/* RDB$SECURITY_CLASS */
   } isc_81;
/**************************************
 *
 *	s h o w _ s e c u r i t y _ c l a s s _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show security classes for a databases.
 *
 **************************************/
	MET_meta_transaction(database, false);

	if (!(database->dbb_capabilities & DBB_cap_security))
		return 0;

	USHORT count = 0;
	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_secur_class])
		S IN RDB$SECURITY_CLASSES WITH S.RDB$SECURITY_CLASS = name*/
	{
        if (!database->dbb_requests[REQ_show_secur_class])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_secur_class], (short) sizeof(isc_80), (char*) isc_80);
	isc_vtov ((const char*) name, (char*) isc_81.isc_82, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_secur_class], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_81, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_secur_class], (short) 1, (short) 135, &isc_83, (short) 0);
	   if (!isc_83.isc_85) break;
		if (fb_utils::exact_name(/*S.RDB$SECURITY_CLASS*/
					 isc_83.isc_86)[0])
		{
			printf("\t%s:\n", /*S.RDB$SECURITY_CLASS*/
					  isc_83.isc_86);
			display_acl(database, /*S.RDB$ACL*/
					      isc_83.isc_84);
		}
		count++;
	/*END_FOR;*/
	   }
	}

	return count;
}


static USHORT show_security_classes_detail( qli_dbb* database)
{
   struct isc_76_struct {
          ISC_QUAD isc_77;	/* RDB$ACL */
          short isc_78;	/* isc_utility */
          char  isc_79 [125];	/* RDB$SECURITY_CLASS */
   } isc_76;
/**************************************
 *
 *	s h o w _ s e c u r i t y _ c l a s s e s _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show security classes for a databases.
 *
 **************************************/
	MET_meta_transaction(database, false);

	if (!(database->dbb_capabilities & DBB_cap_security))
		return 0;

	USHORT count = 0;
	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_secur])
		S IN RDB$SECURITY_CLASSES*/
	{
        if (!database->dbb_requests[REQ_show_secur])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_secur], (short) sizeof(isc_75), (char*) isc_75);
        isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_secur], (FB_API_HANDLE*) &gds_trans, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_secur], (short) 0, (short) 135, &isc_76, (short) 0);
	   if (!isc_76.isc_78) break;
		if (!count)
		{
			ERRQ_msg_put(297, database->dbb_symbol->sym_string);
			// Msg297 Security classes for database %s
		}

		if (fb_utils::exact_name(/*S.RDB$SECURITY_CLASS*/
					 isc_76.isc_79)[0])
		{
			printf("\t%s:\n", /*S.RDB$SECURITY_CLASS*/
					  isc_76.isc_79);
			display_acl(database, /*S.RDB$ACL*/
					      isc_76.isc_77);
		}
		count++;
	/*END_FOR;*/
	   }
	}

	return count;
}


static void show_string(USHORT msg1, TEXT* string1, USHORT msg2, TEXT* string2)
{
/**************************************
 *
 *	s h o w _ s t r i n g
 *
 **************************************
 *
 * Functional description
 *	Show one of two strings and maybe a message, too.
 *
 **************************************/

	if (string2 && (!*string1 || *string1 == ' '))
	{
		msg1 = msg2;
		string1 = string2;
	}

	if (!*string1 || *string1 == ' ')
		return;

	fb_utils::exact_name(string1);
	ERRQ_msg_put(msg1, string1);
}


static void show_sys_trigs( qli_dbb* database)
{
   struct isc_64_struct {
          ISC_QUAD isc_65;	/* RDB$TRIGGER_SOURCE */
          ISC_QUAD isc_66;	/* RDB$DESCRIPTION */
          ISC_INT64 isc_67;	/* RDB$TRIGGER_TYPE */
          ISC_QUAD isc_68;	/* RDB$TRIGGER_BLR */
          short isc_69;	/* isc_utility */
          short isc_70;	/* RDB$TRIGGER_INACTIVE */
          short isc_71;	/* RDB$TRIGGER_SEQUENCE */
          short isc_72;	/* gds__null_flag */
          char  isc_73 [125];	/* RDB$RELATION_NAME */
          char  isc_74 [125];	/* RDB$TRIGGER_NAME */
   } isc_64;
/**************************************
 *
 *	s h o w _ s y s _ t r i g s
 *
 **************************************
 *
 * Functional description
 *	Ask META to print trigger information
 *	for the system.  Since parse
 *	has already swallowed a possible database
 *	qualifier, just assume that the database
 *	is the right one.
 *
 **************************************/
	MET_meta_transaction(database, false);
	USHORT count = 0;

	if (database->dbb_capabilities & DBB_cap_new_triggers)
	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_sys_triggers])
		X IN RDB$TRIGGERS WITH X.RDB$SYSTEM_FLAG EQ 1
			SORTED BY X.RDB$RELATION_NAME, X.RDB$TRIGGER_TYPE,
			X.RDB$TRIGGER_SEQUENCE,
			X.RDB$TRIGGER_NAME*/
	{
        if (!database->dbb_requests[REQ_show_sys_triggers])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_sys_triggers], (short) sizeof(isc_63), (char*) isc_63);
        isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_sys_triggers], (FB_API_HANDLE*) &gds_trans, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_sys_triggers], (short) 0, (short) 290, &isc_64, (short) 0);
	   if (!isc_64.isc_69) break;

		if (!/*X.RDB$TRIGGER_BLR.NULL*/
		     isc_64.isc_72)
		{
			ERRQ_msg_put(379, /*X.RDB$RELATION_NAME*/
					  isc_64.isc_73);
			// Msg379 System Triggers
			show_trigger_header(/*X.RDB$TRIGGER_NAME*/
					    isc_64.isc_74, /*X.RDB$TRIGGER_TYPE*/
  isc_64.isc_67,
								/*X.RDB$TRIGGER_SEQUENCE*/
								isc_64.isc_71,
								/*X.RDB$TRIGGER_INACTIVE*/
								isc_64.isc_70, /*X.RDB$DESCRIPTION*/
  isc_64.isc_66,
								database); //, X.RDB$RELATION_NAME);
			show_blob_info(/*X.RDB$TRIGGER_BLR*/
				       isc_64.isc_68, /*X.RDB$TRIGGER_SOURCE*/
  isc_64.isc_65,
							377,	// Msg377 Source for the trigger is not available.  Trigger BLR:
							376,	// Msg376 Source for the trigger
							database, /*X.RDB$RELATION_NAME*/
								  isc_64.isc_73);
			show_trigger_messages(database, /*X.RDB$TRIGGER_NAME*/
							isc_64.isc_74);
			count++;
		}
	/*END_FOR;*/
	   }
	}

	if (!count)
		ERRQ_msg_put(378);	// Msg378 No system triggers
}


static void show_text_blob(qli_dbb* database,
						   const TEXT* column,
						   USHORT msg1,
						   ISC_QUAD* blob1,
						   USHORT msg2,
						   ISC_QUAD* blob2,
						   bool strip)
{
/**************************************
 *
 *	s h o w _ t e x t _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Display a text blob.
 *
 **************************************/

	if (blob2 && UserBlob::blobIsNull(*blob1))
	{
		blob1 = blob2;
		msg1 = msg2;
	}

	if (UserBlob::blobIsNull(*blob1))
		return;

	if (msg1)
		ERRQ_msg_put(msg1);

	display_text(database, *blob1, column, strip);
}


static void show_trig( qli_rel* relation)
{
/**************************************
 *
 *	s h o w _ t r i g
 *
 **************************************
 *
 * Functional description
 *	Ask META to print trigger information
 *	for a particular relation.  Since parse
 *	has already swallowed a possible database
 *	qualifier, just assume that the database
 *	is the right one.
 *
 **************************************/

	if (!(show_trigger_detail(relation->rel_database, relation->rel_symbol->sym_string)))
	{
		ERRQ_msg_put(129, relation->rel_symbol->sym_string);
		// Msg129 No triggers are defined for relation %s
	}
}


static int show_trigger_detail( qli_dbb* database, const TEXT* relation_name)
{
   struct isc_53_struct {
          ISC_QUAD isc_54;	/* RDB$TRIGGER_SOURCE */
          ISC_QUAD isc_55;	/* RDB$DESCRIPTION */
          ISC_INT64 isc_56;	/* RDB$TRIGGER_TYPE */
          ISC_QUAD isc_57;	/* RDB$TRIGGER_BLR */
          short isc_58;	/* isc_utility */
          short isc_59;	/* RDB$TRIGGER_INACTIVE */
          short isc_60;	/* RDB$TRIGGER_SEQUENCE */
          short isc_61;	/* gds__null_flag */
          char  isc_62 [125];	/* RDB$TRIGGER_NAME */
   } isc_53;
   struct isc_51_struct {
          char  isc_52 [125];	/* RDB$RELATION_NAME */
   } isc_51;
/**************************************
 *
 *	s h o w _ t r i g g e r _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show trigger definitions for a particular
 *	relation.
 *
 **************************************/
	if (!(database->dbb_capabilities & DBB_cap_new_triggers))
		return 0;

	MET_meta_transaction(database, false);
	int count = 0;

	// New style triggers

	if (database->dbb_capabilities & DBB_cap_new_triggers)
	{
		ERRQ_msg_put(365, relation_name);	// Msg365 Triggers for relation %s
		/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_new_trigger])
			X IN RDB$TRIGGERS WITH X.RDB$RELATION_NAME EQ relation_name
				AND(X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG EQ 0)
			SORTED BY X.RDB$TRIGGER_TYPE, X.RDB$TRIGGER_SEQUENCE,
				X.RDB$TRIGGER_NAME*/
		{
                if (!database->dbb_requests[REQ_show_new_trigger])
                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_new_trigger], (short) sizeof(isc_50), (char*) isc_50);
		isc_vtov ((const char*) relation_name, (char*) isc_51.isc_52, 125);
                isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_new_trigger], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_51, (short) 0);
		while (1)
		   {
                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_new_trigger], (short) 1, (short) 165, &isc_53, (short) 0);
		   if (!isc_53.isc_58) break;

			if (!/*X.RDB$TRIGGER_BLR.NULL*/
			     isc_53.isc_61)
			{
				show_trigger_header(/*X.RDB$TRIGGER_NAME*/
						    isc_53.isc_62, /*X.RDB$TRIGGER_TYPE*/
  isc_53.isc_56,
									/*X.RDB$TRIGGER_SEQUENCE*/
									isc_53.isc_60,
									/*X.RDB$TRIGGER_INACTIVE*/
									isc_53.isc_59,
									/*X.RDB$DESCRIPTION*/
									isc_53.isc_55, database);
									//relation_name);
				show_blob_info(/*X.RDB$TRIGGER_BLR*/
					       isc_53.isc_57, /*X.RDB$TRIGGER_SOURCE*/
  isc_53.isc_54,
								377,	// Msg377 Source for the trigger is not available.  Trigger BLR:
								376,	// Msg376 Source for the trigger
								database, relation_name);
				show_trigger_messages(database, /*X.RDB$TRIGGER_NAME*/
								isc_53.isc_62);
				count++;
			}
		/*END_FOR;*/
		   }
		}
		return count;
	}

	// Old style triggers
	// OBSOLETE - 1996-Aug-06 David Schnepper

	// OBSOLETE - Msg298 Triggers for relation %s:
	// OBSOLETE - Msg299 Source for the erase trigger is not available.  Trigger BLR:
	// OBSOLETE - Msg300 Erase trigger for relation %s:
	// OBSOLETE - Msg301 Source for the modify trigger is not available.  Trigger BLR:
	// OBSOLETE - Msg302 Modify trigger for relation %s:
	// OBSOLETE - Msg303 Source for the store trigger is not available.  Trigger BLR:
	// OBSOLETE - Msg304 Store trigger for relation %s:

	return count;
}


static void show_trigger_header(TEXT* name,
								USHORT type,
								USHORT sequence,
								USHORT inactive,
								ISC_QUAD& description,
								qli_dbb* database)
								//const TEXT* relation_name) // unused param
{
/*****************************************************
 *
 *	s h o w _ t r i g g e r _ h e a d e r
 *
 *****************************************************
 *
 * Functional description
 * 	Display header information for a new style
 *	trigger only.
 *
 *****************************************************/

	show_trigger_status(name, type, inactive, sequence);
	show_text_blob(database, "\t    ", 375, &description, 0, NULL, true);
}


static void show_trigger_messages( qli_dbb* database, const TEXT* name)
{
   struct isc_46_struct {
          char  isc_47 [1024];	/* RDB$MESSAGE */
          short isc_48;	/* isc_utility */
          short isc_49;	/* RDB$MESSAGE_NUMBER */
   } isc_46;
   struct isc_44_struct {
          char  isc_45 [125];	/* RDB$TRIGGER_NAME */
   } isc_44;
/*****************************************************
 *
 *	s h o w _ t r i g g e r _ m e s s a g e s
 *
 *****************************************************
 *
 *	 Display error messages associated with
 *       a new style (V3) trigger
 *
 *****************************************************/
	bool first = true;

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_trig_message])
		M IN RDB$TRIGGER_MESSAGES WITH M.RDB$TRIGGER_NAME = name
			SORTED BY M.RDB$MESSAGE_NUMBER*/
	{
        if (!database->dbb_requests[REQ_show_trig_message])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_trig_message], (short) sizeof(isc_43), (char*) isc_43);
	isc_vtov ((const char*) name, (char*) isc_44.isc_45, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_trig_message], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_44, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_trig_message], (short) 1, (short) 1028, &isc_46, (short) 0);
	   if (!isc_46.isc_48) break;

		if (first)
		{
			ERRQ_msg_put(456, name); // msg 456: Messages associated with %s:\n
			first = false;
		}
		ERRQ_msg_put(457, SafeArg() << /*M.RDB$MESSAGE_NUMBER*/
					       isc_46.isc_49 << /*M.RDB$MESSAGE*/
    isc_46.isc_47);
		// msg 457:     message %ld:  %s\n
	/*END_FOR;*/
	   }
	}

	if (!first)
		printf("\n");
}


static void show_trigger_status(TEXT* name, USHORT type, USHORT status, USHORT sequence)
{
/*****************************************************
 *
 *	s h o w _ t r i g g e r _ s t a t u s
 *
 *****************************************************
 *
 *	 Display type and active status of a new style (V3) trigger
 *
 *****************************************************/
	SCHAR trigger_type[16], trigger_active[9];
	int msg_num;

	switch (type)
	{
	case PRE_STORE:
		msg_num = 367;
		break;					// Msg367 pre-store
	case POST_STORE:
		msg_num = 368;
		break;					// Msg368 post-store
	case PRE_MODIFY:
		msg_num = 369;
		break;					// Msg369 pre-modify
	case POST_MODIFY:
		msg_num = 370;
		break;					// Msg370 post-modify
	case PRE_ERASE:
		msg_num = 371;
		break;					// Msg371 pre-erase
	case POST_ERASE:
		msg_num = 372;
		break;					// Msg372 post-erase
	default:
		msg_num = 372;
		break;					// Should never happen, not worth an error
	}

	ERRQ_msg_format(msg_num, sizeof(trigger_type), trigger_type);
	msg_num = status ? 374 : 373;
	ERRQ_msg_format(msg_num, sizeof(trigger_active), trigger_active);

	fb_utils::exact_name(name);
	ERRQ_msg_put(366, SafeArg() << name << trigger_type << sequence << trigger_active);
	// Msg366 Name: %s, Type: %s, Sequence: %d, Active: %s
}


static void show_trigs( qli_dbb* database)
{
/**************************************
 *
 *	s h o w _ t r i g s
 *
 **************************************
 *
 * Functional description
 *	Ask META to print all trigger information
 *	for a particular database or all databases.
 *
 **************************************/

	if (database)
	{
		if (!show_triggers_detail(database))
		{
			ERRQ_msg_put(130, database->dbb_symbol->sym_string);
			// Msg130 No triggers are defined in database %s
		}
	}
	else
	{
		for (database = QLI_databases; database; database = database->dbb_next)
			if (!show_triggers_detail(database))
			{
				ERRQ_msg_put(131, database->dbb_symbol->sym_string);
				// Msg131 No triggers are defined in database %s
			}
	}
}


static int show_triggers_detail( qli_dbb* database)
{
   struct isc_32_struct {
          ISC_QUAD isc_33;	/* RDB$TRIGGER_SOURCE */
          ISC_QUAD isc_34;	/* RDB$DESCRIPTION */
          ISC_INT64 isc_35;	/* RDB$TRIGGER_TYPE */
          ISC_QUAD isc_36;	/* RDB$TRIGGER_BLR */
          short isc_37;	/* isc_utility */
          short isc_38;	/* RDB$TRIGGER_INACTIVE */
          short isc_39;	/* RDB$TRIGGER_SEQUENCE */
          short isc_40;	/* gds__null_flag */
          char  isc_41 [125];	/* RDB$RELATION_NAME */
          char  isc_42 [125];	/* RDB$TRIGGER_NAME */
   } isc_32;
/**************************************
 *
 *	s h o w _ t r i g g e r s _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show trigger definitions for a particular
 *	database
 *
 **************************************/
	MET_meta_transaction(database, false);
	int count = 0;

	if (!(database->dbb_capabilities & DBB_cap_new_triggers))
		return count;

	if (database->dbb_capabilities & DBB_cap_new_triggers)
	{
		// New style triggers

		/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_new_triggers])
			X IN RDB$TRIGGERS WITH X.RDB$SYSTEM_FLAG MISSING
				OR X.RDB$SYSTEM_FLAG EQ 0 SORTED BY X.RDB$RELATION_NAME,
				X.RDB$TRIGGER_TYPE, X.RDB$TRIGGER_SEQUENCE, X.RDB$TRIGGER_NAME*/
		{
                if (!database->dbb_requests[REQ_show_new_triggers])
                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_new_triggers], (short) sizeof(isc_31), (char*) isc_31);
                isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_new_triggers], (FB_API_HANDLE*) &gds_trans, (short) 0);
		while (1)
		   {
                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_new_triggers], (short) 0, (short) 290, &isc_32, (short) 0);
		   if (!isc_32.isc_37) break;
			if (!/*X.RDB$TRIGGER_BLR.NULL*/
			     isc_32.isc_40)
			{
				fb_utils::exact_name(/*X.RDB$RELATION_NAME*/
						     isc_32.isc_41);
				ERRQ_msg_put(381, /*X.RDB$RELATION_NAME*/
						  isc_32.isc_41);
				// Msg365 Triggers for relation %s
				show_trigger_header(/*X.RDB$TRIGGER_NAME*/
						    isc_32.isc_42, /*X.RDB$TRIGGER_TYPE*/
  isc_32.isc_35,
									/*X.RDB$TRIGGER_SEQUENCE*/
									isc_32.isc_39,
									/*X.RDB$TRIGGER_INACTIVE*/
									isc_32.isc_38,
									/*X.RDB$DESCRIPTION*/
									isc_32.isc_34, database);
									//X.RDB$RELATION_NAME);
				show_blob_info(/*X.RDB$TRIGGER_BLR*/
					       isc_32.isc_36, /*X.RDB$TRIGGER_SOURCE*/
  isc_32.isc_33,
							   377,	// Msg377 Source for the trigger is not available.  Trigger BLR:
							   376,	// Msg376 Source for the trigger
							   database, /*X.RDB$RELATION_NAME*/
								     isc_32.isc_41);
				show_trigger_messages(database, /*X.RDB$TRIGGER_NAME*/
								isc_32.isc_42);
				count++;
			}
		/*END_FOR;*/
		   }
		}
	}
	else
	{
		// Old style triggers
		// OBSOLETE - 1996-Aug-06 David Schnepper
		// OBSOLETE - Msg305 Triggers for relation %s:

		// OBSOLETE - Msg306 Source for the erase trigger is not available.  Trigger BLR:
		// OBSOLETE - Msg307 Erase trigger for relation %s:

		// OBSOLETE - Msg308 Source for the modify trigger is not available.  Trigger BLR:
		// OBSOLETE - Msg309 Modify trigger for relation %s:

		// OBSOLETE - Msg310 Source for the store trigger is not available.  Trigger BLR:
		// OBSOLETE - Msg311 Store trigger for relation %s:
	}

	return count;
}


static void show_var( const qli_name* var_name)
{
/**************************************
 *
 *	s h o w _ v a r
 *
 **************************************
 *
 * Functional description
 *	Display a global variables.
 *
 **************************************/
	const qli_fld* variable;

	for (variable = QLI_variables; variable; variable = variable->fld_next)
	{
		if (!strcmp(var_name->nam_string, variable->fld_name->sym_string))
			break;
	}

	if (!variable)
	{
		ERRQ_msg_put(474, var_name->nam_string);	// Msg474 Variable %s has not been declared
		return;
	}

	ERRQ_msg_put(471, variable->fld_name->sym_string);	// Msg471 Variable %s
	ERRQ_msg_put(475);
	printf("\t");
	show_datatype(NULL, variable->fld_dtype,
				  (variable->fld_dtype == dtype_varying) ?
				  	variable->fld_length - 2 : variable->fld_length,
				  variable->fld_scale,
				  variable->fld_sub_type, variable->fld_segment_length,
				  (variable->fld_flags & FLD_array) ? 1 : 0);
	printf("\n");
	if (variable->fld_query_name) {
		ERRQ_msg_put(472, variable->fld_query_name->sym_string);
	}
	if (variable->fld_edit_string)
		ERRQ_msg_put(473, variable->fld_edit_string);
}


static void show_vars()
{
/**************************************
 *
 *	s h o w _ v a r s
 *
 **************************************
 *
 * Functional description
 *	Display global variables.  If there aren't any, don't
 *	display any.
 *
 **************************************/
	ERRQ_msg_put(132);	// Msg132 Variables:
	show_fields(NULL, QLI_variables);
}


static void show_versions()
{
/**************************************
 *
 *	s h o w _ v e r s i o n s
 *
 **************************************
 *
 * Functional description
 *	Show the version for QLI and all databases.
 *
 **************************************/
	ERRQ_msg_put(133, FB_VERSION);	// Msg133 QLI, version %s

	for (qli_dbb* dbb = QLI_databases; dbb; dbb = dbb->dbb_next)
	{
		ERRQ_msg_put(134, dbb->dbb_filename);
		// Msg134 Version(s) for database %s
		isc_version(&dbb->dbb_handle, NULL, NULL);
	}
}


static void show_view( qli_rel* relation)
{
   struct isc_26_struct {
          ISC_QUAD isc_27;	/* RDB$VIEW_BLR */
          ISC_QUAD isc_28;	/* RDB$VIEW_SOURCE */
          short isc_29;	/* isc_utility */
          short isc_30;	/* gds__null_flag */
   } isc_26;
   struct isc_24_struct {
          char  isc_25 [125];	/* RDB$RELATION_NAME */
   } isc_24;
/**************************************
 *
 *	s h o w _ v i e w
 *
 **************************************
 *
 * Functional description
 *	Call MET to show the view definition
 *	if there is one.
 *
 **************************************/
	qli_dbb* database = relation->rel_database;
	MET_meta_transaction(database, false);

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_view])
		X IN RDB$RELATIONS
			WITH X.RDB$RELATION_NAME EQ relation->rel_symbol->sym_string
			AND X.RDB$VIEW_BLR NOT MISSING*/
	{
        if (!database->dbb_requests[REQ_show_view])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_view], (short) sizeof(isc_23), (char*) isc_23);
	isc_vtov ((const char*) relation->rel_symbol->sym_string, (char*) isc_24.isc_25, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_view], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_24, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_view], (short) 1, (short) 20, &isc_26, (short) 0);
	   if (!isc_26.isc_29) break;

		if (/*X.RDB$VIEW_SOURCE.NULL*/
		    isc_26.isc_30)
		{
			ERRQ_msg_put(312, relation->rel_symbol->sym_string);
			// Msg312 View source for relation %s is not available.  View BLR:
			display_blr(database, /*X.RDB$VIEW_BLR*/
					      isc_26.isc_27);
		}
		else
		{
			ERRQ_msg_put(313, relation->rel_symbol->sym_string);
			// Msg313 Relation %s is a view defined as:
			show_text_blob(database, "\t", 0, &/*X.RDB$VIEW_SOURCE*/
							   isc_26.isc_28, 0, NULL, false);
		}
	/*END_FOR;*/
	   }
	}
}


static int show_views_detail( qli_dbb* database)
{
   struct isc_16_struct {
          short isc_17;	/* isc_utility */
          char  isc_18 [125];	/* RDB$RELATION_NAME */
   } isc_16;
   struct isc_14_struct {
          char  isc_15 [125];	/* RDB$RELATION_NAME */
   } isc_14;
   struct isc_20_struct {
          short isc_21;	/* isc_utility */
          char  isc_22 [125];	/* RDB$RELATION_NAME */
   } isc_20;
/**************************************
 *
 *	s h o w _ v i e w s _ d e t a i l
 *
 **************************************
 *
 * Functional description
 *	Show the view definitions.  If none, return 0.
 *
 **************************************/
	MET_meta_transaction(database, false);
	int count = 0;

	/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_views])
		X IN RDB$RELATIONS WITH X.RDB$VIEW_BLR NOT MISSING
			SORTED BY X.RDB$RELATION_NAME*/
	{
        if (!database->dbb_requests[REQ_show_views])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_views], (short) sizeof(isc_19), (char*) isc_19);
        isc_start_request (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_views], (FB_API_HANDLE*) &gds_trans, (short) 0);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_views], (short) 0, (short) 127, &isc_20, (short) 0);
	   if (!isc_20.isc_21) break;

		if (!count++)
		{
			ERRQ_msg_put(316, database->dbb_symbol->sym_string);
			// Msg316 Views in database %s:
		}

		fb_utils::exact_name(/*X.RDB$RELATION_NAME*/
				     isc_20.isc_22);
		ERRQ_msg_put(317, /*X.RDB$RELATION_NAME*/
				  isc_20.isc_22);	// Msg317 %s comprised of:
		/*FOR(REQUEST_HANDLE database->dbb_requests[REQ_show_view_rel])
			V IN RDB$VIEW_RELATIONS
				WITH V.RDB$VIEW_NAME = X.RDB$RELATION_NAME
				SORTED BY V.RDB$RELATION_NAME*/
		{
                if (!database->dbb_requests[REQ_show_view_rel])
                   isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_view_rel], (short) sizeof(isc_13), (char*) isc_13);
		isc_vtov ((const char*) isc_20.isc_22, (char*) isc_14.isc_15, 125);
                isc_start_and_send (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_view_rel], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 125, &isc_14, (short) 0);
		while (1)
		   {
                   isc_receive (NULL, (FB_API_HANDLE*) &database->dbb_requests[REQ_show_view_rel], (short) 1, (short) 127, &isc_16, (short) 0);
		   if (!isc_16.isc_17) break;
			printf("	%s\n", /*V.RDB$RELATION_NAME*/
					       isc_16.isc_18);
		/*END_FOR;*/
		   }
		}

	/*END_FOR;*/
	   }
	}

	return count;
}


static void view_info(qli_dbb* dbb,
					  const TEXT* view,
					  const TEXT* base_field,
					  SSHORT context,
					  SSHORT level)
{
   struct isc_5_struct {
          ISC_QUAD isc_6;	/* RDB$DESCRIPTION */
          short isc_7;	/* isc_utility */
          short isc_8;	/* RDB$VIEW_CONTEXT */
          short isc_9;	/* gds__null_flag */
          short isc_10;	/* gds__null_flag */
          char  isc_11 [125];	/* RDB$RELATION_NAME */
          char  isc_12 [125];	/* RDB$BASE_FIELD */
   } isc_5;
   struct isc_1_struct {
          short isc_2;	/* RDB$VIEW_CONTEXT */
          char  isc_3 [125];	/* RDB$FIELD_NAME */
          char  isc_4 [125];	/* RDB$VIEW_NAME */
   } isc_1;
/**************************************
 *
 *	v i e w _ i n f o
 *
 **************************************
 *
 * Functional description
 *
 *	field came from another relation.
 *	expand on this phenomenon.
 *
 **************************************/
	TEXT spaces[64];

	/*FOR(REQUEST_HANDLE dbb->dbb_requests[REQ_show_view_field] LEVEL level)
		RFR IN RDB$RELATION_FIELDS CROSS VR IN RDB$VIEW_RELATIONS
			WITH RFR.RDB$FIELD_NAME = base_field AND
			RFR.RDB$RELATION_NAME = VR.RDB$RELATION_NAME AND
			VR.RDB$VIEW_NAME = view AND
			VR.RDB$VIEW_CONTEXT = context*/
	{
        if (!dbb->dbb_requests[REQ_show_view_field])
           isc_compile_request (NULL, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &dbb->dbb_requests[REQ_show_view_field], (short) sizeof(isc_0), (char*) isc_0);
	isc_1.isc_2 = context;
	isc_vtov ((const char*) base_field, (char*) isc_1.isc_3, 125);
	isc_vtov ((const char*) view, (char*) isc_1.isc_4, 125);
        isc_start_and_send (NULL, (FB_API_HANDLE*) &dbb->dbb_requests[REQ_show_view_field], (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 252, &isc_1, (short) level);
	while (1)
	   {
           isc_receive (NULL, (FB_API_HANDLE*) &dbb->dbb_requests[REQ_show_view_field], (short) 1, (short) 266, &isc_5, (short) level);
	   if (!isc_5.isc_7) break;
		fb_utils::exact_name(/*RFR.RDB$RELATION_NAME*/
				     isc_5.isc_11);

		// create some space according to how many levels deep we are;
		// this is to avoid using %*s in the printf, which doesn't work for OS/2
		TEXT* p = spaces;
		for (const TEXT* const end = spaces + MIN((level + 2) * 4, static_cast<int>(sizeof(spaces) - 1));
			p < end;)
		{
			*p++ = ' ';
		}
		*p = '\0';

		if (/*RFR.RDB$BASE_FIELD.NULL*/
		    isc_5.isc_10)
		{
			ERRQ_msg_put(507, SafeArg() << spaces << base_field << /*RFR.RDB$RELATION_NAME*/
									       isc_5.isc_11);
		// Msg507 %s Based on field %s of relation %s
		}
		else
		{
			ERRQ_msg_put(508, SafeArg() << spaces << base_field << /*RFR.RDB$RELATION_NAME*/
									       isc_5.isc_11);
		// Msg508 %s Based on field %s of view %s
		}
		show_text_blob(dbb, "\t", 349, &/*RFR.RDB$DESCRIPTION*/
						isc_5.isc_6, 0, NULL, false);

		if (!/*RFR.RDB$DESCRIPTION.NULL*/
		     isc_5.isc_9)
		{
			ERRQ_msg_put(349, SafeArg() << spaces << base_field);
			// Msg349 %sBase field description for %s:
			show_text_blob(dbb, "\t\t", 0, &/*RFR.RDB$DESCRIPTION*/
							isc_5.isc_6, 0, NULL, false);
		}

		if (!/*RFR.RDB$BASE_FIELD.NULL*/
		     isc_5.isc_10 && (dbb->dbb_capabilities & DBB_cap_multi_trans))
		{
			fb_utils::exact_name(/*RFR.RDB$BASE_FIELD*/
					     isc_5.isc_12);
			view_info(dbb, /*RFR.RDB$RELATION_NAME*/
				       isc_5.isc_11, /*RFR.RDB$BASE_FIELD*/
  isc_5.isc_12,
					  /*RFR.RDB$VIEW_CONTEXT*/
					  isc_5.isc_8, level + 1);
		}
	/*END_FOR;*/
	   }
	}
}
